<?php

/*
** theme options panel and metabox settings
** will change some parts of theme via custom style
*/

function ninetheme_custom_css()
{

  // stop on admin pages
    if (is_admin()) {
        return false;
    }

    /* CSS to output */
    $theCSS = '';

    /*************************************************
    ## HEADER SETTINGS
    *************************************************/
    if ( '' != ninetheme_settings('content_width', '') ) {
        $theCSS .= '@media (min-width: 1200px){
        .ninetheme-container.container,
        .ninetheme-container-xl.container-xl {
            max-width: '.ninetheme_settings('content_width', '').'px;
        }}';
    }

    if ( ninetheme_settings('quick_view_width_sm', '') ) {
        $theCSS .= '@media (min-width: 1024px){
        .ninetheme-quickview-wrapper {
            max-width: '.ninetheme_settings('quick_view_width_sm', '').'px;
        }}';
    }
    if ( ninetheme_settings('quick_view_width', '') ) {
        $theCSS .= '@media (min-width: 1200px){
        .ninetheme-quickview-wrapper {
            max-width: '.ninetheme_settings('quick_view_width', '').'px;
        }}';
    }
    if ( ninetheme_settings('quick_shop_width', '') ) {
        $theCSS .= '@media (min-width: 1024px){
        .ninetheme-quickshop-wrapper {
            max-width: '.ninetheme_settings('quick_shop_width', '').'px;
        }}';
    }
    if ( ninetheme_settings('quick_shop_width_sm', '') ) {
        $theCSS .= '@media (min-width: 1200px){
        .ninetheme-quickshop-wrapper {
            max-width: '.ninetheme_settings('quick_shop_width_sm', '').'px;
        }}';
    }

    if ( '' != ninetheme_settings('header_top_height', '') ) {
        $theCSS .= '.ninetheme-header-default-topbar .ninetheme-header-default-inner>div,
        .ninetheme-header-default-topbar .ninetheme-header-top-menu-area>ul>li.menu-item {
            height: '.ninetheme_settings('header_top_height', '').'px;
        }';
    }
    if ( '' != ninetheme_settings('header_middle_height', '') ) {
        $theCSS .= '.ninetheme-header-default-center,
        .ninetheme-header-default-center .ninetheme-header-top-menu-area>ul>li.menu-item {
            height: '.ninetheme_settings('header_middle_height', '').'px;
        }';
    }
    if ( '' != ninetheme_settings('header_bottom_height', '') ) {
        $theCSS .= '.ninetheme-header-default-bottom .ninetheme-header-default-inner>div,
        .ninetheme-header-default-bottom .ninetheme-header-top-menu-area>ul>li.menu-item {
            height: '.ninetheme_settings('header_bottom_height', '').'px;
        }';
    }

    $is_first = is_rtl() ? 'first' : 'last';
    $is_last = is_rtl() ? 'last' : 'first';

    if ( ninetheme_settings('header_right_item_spacing', '') ) {
        $theCSS .= '.ninetheme-header-default-center .ninetheme-header-top-right .ninetheme-header-default-inner>div:not(:'.$is_last.'-child) {
            margin-left: '.ninetheme_settings('header_right_item_spacing', '').'px;
        }';
    }
    if ( ninetheme_settings('header_left_item_spacing', '') ) {
        $is_first = is_rtl() ? 'first' : 'last';
        $theCSS .= '.ninetheme-header-default-center .ninetheme-header-top-left .ninetheme-header-default-inner>div:not(:'.$is_first.'-child) {
            margin-right: '.ninetheme_settings('header_left_item_spacing', '').'px;
        }';
    }
    if ( ninetheme_settings('header_top_right_item_spacing', '') ) {

        $theCSS .= '.ninetheme-header-default-topbar .ninetheme-header-top-right .ninetheme-header-default-inner>div:not(:'.$is_last.'-child) {
            margin-left: '.ninetheme_settings('header_top_right_item_spacing', '').'px;
        }';
    }
    if ( ninetheme_settings('header_top_left_item_spacing', '') ) {
        $theCSS .= '.ninetheme-header-default-topbar .ninetheme-header-top-left .ninetheme-header-default-inner>div:not(:'.$is_first.'-child) {
            margin-right: '.ninetheme_settings('header_top_left_item_spacing', '').'px;
        }';
    }
    if ( ninetheme_settings('header_bottom_right_item_spacing', '') ) {
        $theCSS .= '.ninetheme-header-default-bottom .ninetheme-header-top-right .ninetheme-header-default-inner>div:not(:'.$is_last.'-child) {
            margin-left: '.ninetheme_settings('header_bottom_right_item_spacing', '').'px;
        }';
    }
    if ( ninetheme_settings('header_bottom_left_item_spacing', '') ) {
        $theCSS .= '.ninetheme-header-default-bottom .ninetheme-header-top-left .ninetheme-header-default-inner>div:not(:'.$is_first.'-child) {
            margin-right: '.ninetheme_settings('header_bottom_left_item_spacing', '').'px;
        }';
    }

    if ( ninetheme_settings('header_buttons_spacing', '') ) {
        $theCSS .= '.ninetheme-header-default .top-action-btn {
            margin-left: '.ninetheme_settings('header_buttons_spacing', '').'px;
        }';
    }
    if ( ninetheme_settings('sidebar_menu_content_width', '') ) {
        $theCSS .= '.ninetheme-header-mobile {
            max-width: '.ninetheme_settings('sidebar_menu_content_width', '').'px;
        }';
    }
    if ( ninetheme_settings('sidebar_menu_bar_width', '') ) {
        $theCSS .= '.ninetheme-header-mobile-sidebar {
            min-width: '.ninetheme_settings('sidebar_menu_bar_width', '').'px;
        }';
    }
    // logo size
    if ( ninetheme_settings('logo_size', '') ) {
        $theCSS .= '.nt-logo img {
            max-width: '.ninetheme_settings('logo_size', '').'px;
        }';
    }
    if ( ninetheme_settings('sticky_logo_size', '') ) {
        $theCSS .= '.nt-logo img.sticky-logo {
            max-width: '.ninetheme_settings('sticky_logo_size', '').'px;
        }';
    }
    if ( ninetheme_settings('mobile_logo_size', '') ) {
        $theCSS .= '.ninetheme-header-mobile-logo .nt-logo img {
            max-width: '.ninetheme_settings('mobile_logo_size', '').'px;
        }';
    }
    if ( ninetheme_settings('sidebar_logo_size', '') ) {
        $theCSS .= '.ninetheme-header-mobile-sidebar-logo .nt-logo img {
            max-width: '.ninetheme_settings('sidebar_logo_size', '').'px;
        }';
    }

    if ( '1' == apply_filters('ninetheme_theme_layout_mode', ninetheme_settings('theme_layout_mode', 'theme-layout-default' ) ) ) {

        if ( '' != ninetheme_settings('theme_boxed_mode_wrapper_width', '') ) {
            $theCSS .= 'body.boxed-mode-enabled #wrapper {
                max-width: '.ninetheme_settings('theme_boxed_mode_wrapper_width', '').'px;margin: 0 auto;
            }';
        }
        if ( '' != ninetheme_settings('theme_boxed_body_bgclr', '') ) {
            $theCSS .= 'body.boxed-mode-enabled {
                background-color: '.ninetheme_settings('theme_boxed_body_bgclr', '').';
            }';
        }
        if ( '' != ninetheme_settings('theme_boxed_wrapper_bgclr', '') ) {
            $theCSS .= 'body.boxed-mode-enabled #wrapper {
                background-color: '.ninetheme_settings('theme_boxed_wrapper_bgclr', '').';
            }';
        }
    }

    /*************************************************
    ## PRELOADER SETTINGS
    *************************************************/
    if ( '0' != ninetheme_settings('preloader_visibility') ) {

        $pretype = ninetheme_settings('pre_type', 'default');
        $prebg = ninetheme_settings('pre_bg', '#fff');
        $prebg = $prebg ? $prebg : '#f1f1f1';
        $spinclr = ninetheme_settings('pre_spin', '#000');
        $spinclr = $spinclr ? $spinclr : '#000';
        if ( 'default' == $pretype ) {
            $theCSS .= 'body.dark .pace, body.light .pace { background-color: '. esc_attr( $spinclr ) .';}';
            $theCSS .= '#preloader:after, #preloader:before{ background-color:'. esc_attr( $prebg ) .';}';
        }

        $theCSS .= 'div#nt-preloader {background-color: '. esc_attr($prebg) .';overflow: hidden;background-repeat: no-repeat;background-position: center center;height: 100%;left: 0;position: fixed;top: 0;width: 100%;z-index: 9999999;}';
        $spin_rgb = ninetheme_hex2rgb($spinclr);

        if ('01' == $pretype) {
            $theCSS .= '.loader01 {width: 56px;height: 56px;border: 8px solid '. $spinclr .';border-right-color: transparent;border-radius: 50%;position: relative;animation: loader-rotate 1s linear infinite;top: 50%;margin: -28px auto 0; }.loader01::after {content: "";width: 8px;height: 8px;background: '. $spinclr .';border-radius: 50%;position: absolute;top: -1px;left: 33px; }@keyframes loader-rotate {0% {transform: rotate(0); }100% {transform: rotate(360deg); } }';
        }
        if ('02' == $pretype) {
            $theCSS .= '.loader02 {width: 56px;height: 56px;border: 8px solid rgba('. $spin_rgb .', 0.25);border-top-color: '. $spinclr .';border-radius: 50%;position: relative;animation: loader-rotate 1s linear infinite;top: 50%;margin: -28px auto 0; }@keyframes loader-rotate {0% {transform: rotate(0); }100% {transform: rotate(360deg); } }';
        }
        if ('03' == $pretype) {
            $theCSS .= '.loader03 {width: 56px;height: 56px;border: 8px solid transparent;border-top-color: '. $spinclr .';border-bottom-color: '. $spinclr .';border-radius: 50%;position: relative;animation: loader-rotate 1s linear infinite;top: 50%;margin: -28px auto 0; }@keyframes loader-rotate {0% {transform: rotate(0); }100% {transform: rotate(360deg); } }';
        }
        if ('04' == $pretype) {
            $theCSS .= '.loader04 {width: 56px;height: 56px;border: 2px solid rgba('. $spin_rgb .', 0.5);border-radius: 50%;position: relative;animation: loader-rotate 1s ease-in-out infinite;top: 50%;margin: -28px auto 0; }.loader04::after {content: "";width: 10px;height: 10px;border-radius: 50%;background: '. $spinclr .';position: absolute;top: -6px;left: 50%;margin-left: -5px; }@keyframes loader-rotate {0% {transform: rotate(0); }100% {transform: rotate(360deg); } }';
        }
        if ('05' == $pretype) {
            $theCSS .= '.loader05 {width: 56px;height: 56px;border: 4px solid '. $spinclr .';border-radius: 50%;position: relative;animation: loader-scale 1s ease-out infinite;top: 50%;margin: -28px auto 0; }@keyframes loader-scale {0% {transform: scale(0);opacity: 0; }50% {opacity: 1; }100% {transform: scale(1);opacity: 0; } }';
        }
        if ('06' == $pretype) {
            $theCSS .= '.loader06 {width: 56px;height: 56px;border: 4px solid transparent;border-radius: 50%;position: relative;top: 50%;margin: -28px auto 0; }.loader06::before {content: "";border: 4px solid rgba('. $spin_rgb .', 0.5);border-radius: 50%;width: 67.2px;height: 67.2px;position: absolute;top: -9.6px;left: -9.6px;animation: loader-scale 1s ease-out infinite;animation-delay: 1s;opacity: 0; }.loader06::after {content: "";border: 4px solid '. $spinclr .';border-radius: 50%;width: 56px;height: 56px;position: absolute;top: -4px;left: -4px;animation: loader-scale 1s ease-out infinite;animation-delay: 0.5s; }@keyframes loader-scale {0% {transform: scale(0);opacity: 0; }50% {opacity: 1; }100% {transform: scale(1);opacity: 0; } }';
        }
        if ('07' == $pretype) {
            $theCSS .= '.loader07 {width: 16px;height: 16px;border-radius: 50%;position: relative;animation: loader-circles 1s linear infinite;top: 50%;margin: -8px auto 0; }@keyframes loader-circles {0% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.05), 19px -19px 0 0 rgba('. $spin_rgb .', 0.1), 27px 0 0 0 rgba('. $spin_rgb .', 0.2), 19px 19px 0 0 rgba('. $spin_rgb .', 0.3), 0 27px 0 0 rgba('. $spin_rgb .', 0.4), -19px 19px 0 0 rgba('. $spin_rgb .', 0.6), -27px 0 0 0 rgba('. $spin_rgb .', 0.8), -19px -19px 0 0 '. $spinclr .'; }12.5% {box-shadow: 0 -27px 0 0 '. $spinclr .', 19px -19px 0 0 rgba('. $spin_rgb .', 0.05), 27px 0 0 0 rgba('. $spin_rgb .', 0.1), 19px 19px 0 0 rgba('. $spin_rgb .', 0.2), 0 27px 0 0 rgba('. $spin_rgb .', 0.3), -19px 19px 0 0 rgba('. $spin_rgb .', 0.4), -27px 0 0 0 rgba('. $spin_rgb .', 0.6), -19px -19px 0 0 rgba('. $spin_rgb .', 0.8); }25% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.8), 19px -19px 0 0 '. $spinclr .', 27px 0 0 0 rgba('. $spin_rgb .', 0.05), 19px 19px 0 0 rgba('. $spin_rgb .', 0.1), 0 27px 0 0 rgba('. $spin_rgb .', 0.2), -19px 19px 0 0 rgba('. $spin_rgb .', 0.3), -27px 0 0 0 rgba('. $spin_rgb .', 0.4), -19px -19px 0 0 rgba('. $spin_rgb .', 0.6); }37.5% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.6), 19px -19px 0 0 rgba('. $spin_rgb .', 0.8), 27px 0 0 0 '. $spinclr .', 19px 19px 0 0 rgba('. $spin_rgb .', 0.05), 0 27px 0 0 rgba('. $spin_rgb .', 0.1), -19px 19px 0 0 rgba('. $spin_rgb .', 0.2), -27px 0 0 0 rgba('. $spin_rgb .', 0.3), -19px -19px 0 0 rgba('. $spin_rgb .', 0.4); }50% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.4), 19px -19px 0 0 rgba('. $spin_rgb .', 0.6), 27px 0 0 0 rgba('. $spin_rgb .', 0.8), 19px 19px 0 0 '. $spinclr .', 0 27px 0 0 rgba('. $spin_rgb .', 0.05), -19px 19px 0 0 rgba('. $spin_rgb .', 0.1), -27px 0 0 0 rgba('. $spin_rgb .', 0.2), -19px -19px 0 0 rgba('. $spin_rgb .', 0.3); }62.5% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.3), 19px -19px 0 0 rgba('. $spin_rgb .', 0.4), 27px 0 0 0 rgba('. $spin_rgb .', 0.6), 19px 19px 0 0 rgba('. $spin_rgb .', 0.8), 0 27px 0 0 '. $spinclr .', -19px 19px 0 0 rgba('. $spin_rgb .', 0.05), -27px 0 0 0 rgba('. $spin_rgb .', 0.1), -19px -19px 0 0 rgba('. $spin_rgb .', 0.2); }75% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.2), 19px -19px 0 0 rgba('. $spin_rgb .', 0.3), 27px 0 0 0 rgba('. $spin_rgb .', 0.4), 19px 19px 0 0 rgba('. $spin_rgb .', 0.6), 0 27px 0 0 rgba('. $spin_rgb .', 0.8), -19px 19px 0 0 '. $spinclr .', -27px 0 0 0 rgba('. $spin_rgb .', 0.05), -19px -19px 0 0 rgba('. $spin_rgb .', 0.1); }87.5% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.1), 19px -19px 0 0 rgba('. $spin_rgb .', 0.2), 27px 0 0 0 rgba('. $spin_rgb .', 0.3), 19px 19px 0 0 rgba('. $spin_rgb .', 0.4), 0 27px 0 0 rgba('. $spin_rgb .', 0.6), -19px 19px 0 0 rgba('. $spin_rgb .', 0.8), -27px 0 0 0 '. $spinclr .', -19px -19px 0 0 rgba('. $spin_rgb .', 0.05); }100% {box-shadow: 0 -27px 0 0 rgba('. $spin_rgb .', 0.05), 19px -19px 0 0 rgba('. $spin_rgb .', 0.1), 27px 0 0 0 rgba('. $spin_rgb .', 0.2), 19px 19px 0 0 rgba('. $spin_rgb .', 0.3), 0 27px 0 0 rgba('. $spin_rgb .', 0.4), -19px 19px 0 0 rgba('. $spin_rgb .', 0.6), -27px 0 0 0 rgba('. $spin_rgb .', 0.8), -19px -19px 0 0 '. $spinclr .'; } }';
        }
        if ('08' == $pretype) {
            $theCSS .= '.loader08 {width: 20px;height: 20px;position: relative;animation: loader08 1s ease infinite;top: 50%;margin: -46px auto 0; }@keyframes loader08 {0%, 100% {box-shadow: -13px 20px 0 '. $spinclr .', 13px 20px 0 rgba('. $spin_rgb .', 0.2), 13px 46px 0 rgba('. $spin_rgb .', 0.2), -13px 46px 0 rgba('. $spin_rgb .', 0.2); }25% {box-shadow: -13px 20px 0 rgba('. $spin_rgb .', 0.2), 13px 20px 0 '. $spinclr .', 13px 46px 0 rgba('. $spin_rgb .', 0.2), -13px 46px 0 rgba('. $spin_rgb .', 0.2); }50% {box-shadow: -13px 20px 0 rgba('. $spin_rgb .', 0.2), 13px 20px 0 rgba('. $spin_rgb .', 0.2), 13px 46px 0 '. $spinclr .', -13px 46px 0 rgba('. $spin_rgb .', 0.2); }75% {box-shadow: -13px 20px 0 rgba('. $spin_rgb .', 0.2), 13px 20px 0 rgba('. $spin_rgb .', 0.2), 13px 46px 0 rgba('. $spin_rgb .', 0.2), -13px 46px 0 '. $spinclr .'; } }';
        }
        if ('09' == $pretype) {
            $theCSS .= '.loader09 {width: 10px;height: 48px;background: '. $spinclr .';position: relative;animation: loader09 1s ease-in-out infinite;animation-delay: 0.4s;top: 50%;margin: -28px auto 0; }.loader09::after, .loader09::before {content:  "";position: absolute;width: 10px;height: 48px;background: '. $spinclr .';animation: loader09 1s ease-in-out infinite; }.loader09::before {right: 18px;animation-delay: 0.2s; }.loader09::after {left: 18px;animation-delay: 0.6s; }@keyframes loader09 {0%, 100% {box-shadow: 0 0 0 '. $spinclr .', 0 0 0 '. $spinclr .'; }50% {box-shadow: 0 -8px 0 '. $spinclr .', 0 8px 0 '. $spinclr .'; } }';
        }
        if ('10' == $pretype) {
            $theCSS .= '.loader10 {width: 28px;height: 28px;border-radius: 50%;position: relative;animation: loader10 0.9s ease alternate infinite;animation-delay: 0.36s;top: 50%;margin: -42px auto 0; }.loader10::after, .loader10::before {content: "";position: absolute;width: 28px;height: 28px;border-radius: 50%;animation: loader10 0.9s ease alternate infinite; }.loader10::before {left: -40px;animation-delay: 0.18s; }.loader10::after {right: -40px;animation-delay: 0.54s; }@keyframes loader10 {0% {box-shadow: 0 28px 0 -28px '. $spinclr .'; }100% {box-shadow: 0 28px 0 '. $spinclr .'; } }';
        }
        if ('11' == $pretype) {
            $theCSS .= '.loader11 {width: 20px;height: 20px;border-radius: 50%;box-shadow: 0 40px 0 '. $spinclr .';position: relative;animation: loader11 0.8s ease-in-out alternate infinite;animation-delay: 0.32s;top: 50%;margin: -50px auto 0; }.loader11::after, .loader11::before {content:  "";position: absolute;width: 20px;height: 20px;border-radius: 50%;box-shadow: 0 40px 0 '. $spinclr .';animation: loader11 0.8s ease-in-out alternate infinite; }.loader11::before {left: -30px;animation-delay: 0.48s;}.loader11::after {right: -30px;animation-delay: 0.16s; }@keyframes loader11 {0% {box-shadow: 0 40px 0 '. $spinclr .'; }100% {box-shadow: 0 20px 0 '. $spinclr .'; } }';
        }
        if ('12' == $pretype) {
            $theCSS .= '.loader12 {width: 20px;height: 20px;border-radius: 50%;position: relative;animation: loader12 1s linear alternate infinite;top: 50%;margin: -50px auto 0; }@keyframes loader12 {0% {box-shadow: -60px 40px 0 2px '. $spinclr .', -30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 0 40px 0 0 rgba('. $spin_rgb .', 0.2), 30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 60px 40px 0 0 rgba('. $spin_rgb .', 0.2); }25% {box-shadow: -60px 40px 0 0 rgba('. $spin_rgb .', 0.2), -30px 40px 0 2px '. $spinclr .', 0 40px 0 0 rgba('. $spin_rgb .', 0.2), 30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 60px 40px 0 0 rgba('. $spin_rgb .', 0.2); }50% {box-shadow: -60px 40px 0 0 rgba('. $spin_rgb .', 0.2), -30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 0 40px 0 2px '. $spinclr .', 30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 60px 40px 0 0 rgba('. $spin_rgb .', 0.2); }75% {box-shadow: -60px 40px 0 0 rgba('. $spin_rgb .', 0.2), -30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 0 40px 0 0 rgba('. $spin_rgb .', 0.2), 30px 40px 0 2px '. $spinclr .', 60px 40px 0 0 rgba('. $spin_rgb .', 0.2); }100% {box-shadow: -60px 40px 0 0 rgba('. $spin_rgb .', 0.2), -30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 0 40px 0 0 rgba('. $spin_rgb .', 0.2), 30px 40px 0 0 rgba('. $spin_rgb .', 0.2), 60px 40px 0 2px '. $spinclr .'; } }';
        }
    }

    $root_clr1 = ninetheme_settings( 'theme_clr1' );
    $root_clr2 = ninetheme_settings( 'theme_clr2' );
    $root_clr3 = ninetheme_settings( 'theme_clr3' );
    $root_clr4 = ninetheme_settings( 'theme_clr4' );
    $root_clr5 = ninetheme_settings( 'theme_clr5' );
    $root_clr6 = ninetheme_settings( 'theme_clr6' );
    $root_clr7 = ninetheme_settings( 'theme_clr7' );
    $root_clr8 = ninetheme_settings( 'theme_clr8' );
    $root_clr9 = ninetheme_settings( 'theme_clr9' );
    $root_clr10 = ninetheme_settings( 'theme_clr10' );
    $root_clr11 = ninetheme_settings( 'theme_clr11' );
    $root_clr12 = ninetheme_settings( 'theme_clr12' );
    $root_clr13 = ninetheme_settings( 'theme_clr13' );
    $root_clr14 = ninetheme_settings( 'theme_clr14' );
    $root_clr15 = ninetheme_settings( 'theme_clr15' );
    $root_clr16 = ninetheme_settings( 'theme_clr16' );
    $root_clr17 = ninetheme_settings( 'theme_clr17' );
    $root_clr18 = ninetheme_settings( 'theme_clr18' );
    $root_clr19 = ninetheme_settings( 'theme_clr19' );
    $root_clr20 = ninetheme_settings( 'theme_clr20' );
    $root_clr21 = ninetheme_settings( 'theme_clr21' );
    $root_clr22 = ninetheme_settings( 'theme_clr22' );
    $root_clr23 = ninetheme_settings( 'theme_clr23' );
    $root_clr24 = ninetheme_settings( 'theme_clr24' );
    $root_clr25 = ninetheme_settings( 'theme_clr25' );
    $root_clr26 = ninetheme_settings( 'theme_clr26' );

    if( $root_clr1
    || $root_clr2
    || $root_clr3
    || $root_clr4
    || $root_clr5
    || $root_clr6
    || $root_clr7
    || $root_clr8
    || $root_clr9
    || $root_clr10
    || $root_clr11
    || $root_clr12
    || $root_clr13
    || $root_clr14
    || $root_clr15
    || $root_clr16
    || $root_clr17
    || $root_clr18
    || $root_clr19
    || $root_clr20
    || $root_clr21
    || $root_clr22
    || $root_clr23
    || $root_clr24
    || $root_clr25
    || $root_clr26 ) {
        $theCSS .= ':root {';
            $theCSS .= $root_clr1 ? '--ninetheme-primary: '.$root_clr1.';' : '';
            $theCSS .= $root_clr2 ? '--ninetheme-secondary: '.$root_clr2.';' : '';
            $theCSS .= $root_clr3 ? '--ninetheme-text: '.$root_clr3.';' : '';
            $theCSS .= $root_clr4 ? '--ninetheme-text-soft: '.$root_clr4.';' : '';
            $theCSS .= $root_clr5 ? '--ninetheme-dark: '.$root_clr5.';' : '';
            $theCSS .= $root_clr6 ? '--ninetheme-dark-soft: '.$root_clr6.';' : '';
            $theCSS .= $root_clr7 ? '--ninetheme-light: '.$root_clr7.';' : '';
            $theCSS .= $root_clr8 ? '--ninetheme-light-soft: '.$root_clr8.';' : '';
            $theCSS .= $root_clr9 ? '--ninetheme-gray: '.$root_clr9.';' : '';
            $theCSS .= $root_clr10 ? '--ninetheme-gray-soft: '.$root_clr10.';' : '';
            $theCSS .= $root_clr11 ? '--ninetheme-border: '.$root_clr11.';' : '';
            $theCSS .= $root_clr12 ? '--ninetheme-dark-border: '.$root_clr12.';' : '';
            $theCSS .= $root_clr13 ? '--ninetheme-trans-border: '.$root_clr13.';' : '';
            $theCSS .= $root_clr14 ? '--ninetheme-success: '.$root_clr14.';' : '';
            $theCSS .= $root_clr15 ? '--ninetheme-red: '.$root_clr15.';' : '';
            $theCSS .= $root_clr16 ? '--ninetheme-red-soft: '.$root_clr16.';' : '';
            $theCSS .= $root_clr17 ? '--ninetheme-green: '.$root_clr17.';' : '';
            $theCSS .= $root_clr18 ? '--ninetheme-green-soft: '.$root_clr18.';' : '';
            $theCSS .= $root_clr19 ? '--ninetheme-purple: '.$root_clr19.';' : '';
            $theCSS .= $root_clr20 ? '--ninetheme-purple-soft: '.$root_clr20.';' : '';
            $theCSS .= $root_clr21 ? '--ninetheme-yellow: '.$root_clr21.';' : '';
            $theCSS .= $root_clr22 ? '--ninetheme-yellow-soft: '.$root_clr22.';' : '';
            $theCSS .= $root_clr23 ? '--ninetheme-brown: '.$root_clr23.';' : '';
            $theCSS .= $root_clr24 ? '--ninetheme-blue: '.$root_clr24.';' : '';
            $theCSS .= $root_clr25 ? '--ninetheme-blue-soft: '.$root_clr25.';' : '';
            $theCSS .= $root_clr26 ? '--ninetheme-blue-dark: '.$root_clr26.';' : '';
        $theCSS .= '}';
    }
    // use page/post ID for page settings
    $page_id = get_the_ID();

    /*************************************************
    ## THEME PAGINATION
    *************************************************/
    // pagination color
    $pag_radius          = ninetheme_settings('pagination_border_radius');
    $pag_align           = ninetheme_settings('pagination_alignment');
    $title_line          = ninetheme_settings('post_title_max_line');
    $excerpt_line        = ninetheme_settings('post_excerpt_max_line');
    $mobile_breakpoint   = ninetheme_settings('mobile_header_breakpoint');
    $hints_visibility    = ninetheme_settings('product_hints_visibility');
    $addtocartbt_radius  = ninetheme_settings('shop_addtocartbtn_brd_radius');
    $quantity_radius     = ninetheme_settings('shop_loop_quantity_radius');
    $quantity_btn_radius = ninetheme_settings('shop_loop_quantity_buttons_radius');
    $hints_bgcolor       = ninetheme_settings('product_hints_bgcolor');

    if ( $mobile_breakpoint != 1280 ) {
        $theCSS .= '@media (min-width: '.$mobile_breakpoint.'px) {header.ninetheme-header-default {display: block;}}';
        $theCSS .= '@media (min-width: '.$mobile_breakpoint.'px) {.ninetheme-header-mobile-top-wrapper {display: none;}}';
        $theCSS .= '@media (max-width: '.$mobile_breakpoint.'px) {
            header.ninetheme-header-default {display: none;}
            .ninetheme-header-mobile-top-wrapper {display: block;}
        }';
    }

    // pagination border radius
    if ( $pag_radius ) {
        $theCSS .= '.nt-pagination .nt-pagination-item .nt-pagination-link,
        .ninetheme-woocommerce-pagination ul li a,
        .ninetheme-woocommerce-pagination ul li span { border-radius: '. esc_attr( $pag_radius ) .'px; }';
    }
    // pagination border radius
    if ( $pag_align ) {
        $theCSS .= 'body .ninetheme-woocommerce-pagination ul {justify-content: '. esc_attr( $pag_align ) .';}';
    }
    if ( $title_line ) {
        $theCSS .= '.ninetheme-blog-post-content .ninetheme-post-title {
           overflow: hidden;
           display: -webkit-box;
           -webkit-line-clamp: '. esc_attr( $title_line ).';
                   line-clamp: '. esc_attr( $title_line ).';
           -webkit-box-orient: vertical;}';
    }
    if ( $excerpt_line ) {
        $theCSS .= '.ninetheme-blog-post-content .ninetheme-post-excerpt {
           overflow: hidden;
           display: -webkit-box;
           -webkit-line-clamp: '. esc_attr( $excerpt_line ).';
                   line-clamp: '. esc_attr( $excerpt_line ).';
           -webkit-box-orient: vertical;}';
    }
    if ( '0' == $hints_visibility ) {
        $theCSS .= '.ninetheme-hint,.ninetheme-social-icons a:before,.ninetheme-social-icons a:after {display: none!important;}';
    }
    if ( '1' == $hints_visibility && $hints_bgcolor ) {
        $theCSS .= '.hint-top .ninetheme-hint:before,.ninetheme-social-icons a:before {border-top-color: '.$hints_bgcolor.';}';
        $theCSS .= '.hint-left .ninetheme-hint:before {border-left-color: '.$hints_bgcolor.';}';
    }
    if ( $addtocartbt_radius ) {
        $theCSS .= '.ninetheme-loop-product-type-1 .ninetheme-btn, .ninetheme-loop-product-type-3 .ninetheme-btn, .ninetheme-loop-product-type-list .ninetheme-btn {border-radius: '.$addtocartbt_radius.'px;}';
    }
    if ( $quantity_radius ) {
        $theCSS .= '.ninetheme-loop-product .ninetheme-loop-quantity {border-radius: '.$quantity_radius.'px;}';
    }
    if ( $quantity_btn_radius ) {
        $theCSS .= '.ninetheme-loop-product .ninetheme-loop-quantity-button {border-radius: '.$quantity_btn_radius.'px;}';
    }


    /*************************************************
    ## PAGE METABOX SETTINGS
    *************************************************/
    if ( class_exists( 'WooCommerce' ) && is_shop() ) {
        if ( isset( $_GET['container'] ) && $_GET['container'] == 'full' ) {
            $theCSS .= '@media (min-width: 1200px){
            .ninetheme-container.container,
            .ninetheme-container-xl.container-xl,
            .elementor-section.elementor-section-boxed > .elementor-container{
                max-width: 1600px;
            }}';
            $theCSS .= '@media (min-width: 1200px){
            body.has-header-boxed-layout .ninetheme-header-default-bottom-sticky>.container-xl{
                max-width: 1580px;
            }}';
        }
    }

    if ( class_exists( 'WooCommerce' ) && is_product() ) {

        $summarybg_type_ot = ninetheme_settings( 'single_shop_showcase_bg_type', '' );
        $summarybg_type_mb = get_post_meta( $page_id, 'ninetheme_showcase_bg_type', true );
        $summarybg_type    = $summarybg_type_mb ? $summarybg_type_mb : $summarybg_type_ot;
        $summarybg_type    = apply_filters('ninetheme_showcase_bg_type', $summarybg_type );

        $summarybg_ot   = ninetheme_settings( 'single_shop_showcase_custom_bgcolor', '' );
        $summarybg_mb   = get_post_meta( $page_id, 'ninetheme_showcase_custom_bgcolor', true );
        $summarybg      = $summarybg_mb ? $summarybg_mb : $summarybg_ot;
        $summarybg      = apply_filters('ninetheme_showcase_custom_bgcolor', $summarybg );

        $summarytext_ot = ninetheme_settings( 'single_shop_showcase_custom_textcolor', '' );
        $summarytext_mb = get_post_meta( $page_id, 'ninetheme_showcase_custom_textcolor', true );
        $summarytext    = $summarytext_mb ? $summarytext_mb : $summarytext_ot;
        $summarytext    = apply_filters('ninetheme_showcase_custom_textcolor', $summarytext );

        if ( 'custom' == $summarybg_type ) {
            if ( $summarybg ) {
                $theCSS .= '.page-'.$page_id.' .ninetheme-product-showcase, .postid-'.$page_id.' .ninetheme-product-showcase.ninetheme-bg-custom { background-color:'.esc_url( $summarybg ).'; }';
            }
            if ( $summarytext ) {
                $theCSS .= '.ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-summary-item.ninetheme-product-title,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-summary-item.ninetheme-price,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-price span.del > span,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-summary-item .woocommerce-product-details__short-description,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-small-title,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-small-title a,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-view,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-view span,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-estimated-delivery,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-estimated-delivery span,
                .ninetheme-product-showcase.ninetheme-bg-custom a.ninetheme-open-popup,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-product-meta .posted_in,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-product-meta .tagged_as,
                .ninetheme-product-showcase.ninetheme-bg-custom .quantity-button.plus,
                .ninetheme-product-showcase.ninetheme-bg-custom .quantity-button.minus,
                .ninetheme-product-showcase.ninetheme-bg-custom .input-text.qty,
                .ninetheme-product-showcase.ninetheme-bg-custom .woocommerce-product-details__short-description,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-single-product-stock .stock-details span,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-breadcrumb li,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-breadcrumb li a,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-product-meta .ninetheme-brands a,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-product-meta .posted_in a,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-product-meta .tagged_as a,
                .ninetheme-product-showcase.ninetheme-bg-custom span.ninetheme-shop-link-icon,
                .ninetheme-product-showcase.ninetheme-bg-custom .product-nav-link,
                .ninetheme-product-showcase.ninetheme-bg-custom .ninetheme-product-summary .ninetheme-product-meta .ninetheme-brands {
                    color: '.esc_url( $summarytext ).';
                }
                .ninetheme-product-showcase.ninetheme-bg-custom span.ninetheme-shop-link-icon:before,
                .ninetheme-product-showcase.ninetheme-bg-custom span.ninetheme-shop-link-icon:after {
                    border-color: '.esc_url( $summarytext ).';
                }';
            }
        }

        $product_header_mb   = get_post_meta( $page_id, 'ninetheme_product_header_type', true );
        if ( 'custom' == $product_header_mb ) {
            $header_bgcolor           = get_post_meta( $page_id, 'ninetheme_product_header_bgcolor', true );
            $menuitem_color           = get_post_meta( $page_id, 'ninetheme_product_header_menuitem_color', true );
            $menuitem_hvrcolor        = get_post_meta( $page_id, 'ninetheme_product_header_menuitem_hvrcolor', true );
            $svgicon_color            = get_post_meta( $page_id, 'ninetheme_product_header_svgicon_color', true );
            $counter_bgcolor          = get_post_meta( $page_id, 'ninetheme_product_header_counter_bgcolor', true );
            $counter_color            = get_post_meta( $page_id, 'ninetheme_product_header_counter_color', true );
            $sticky_header_bgcolor    = get_post_meta( $page_id, 'ninetheme_product_sticky_header_bgcolor', true );
            $sticky_menuitem_color    = get_post_meta( $page_id, 'ninetheme_product_sticky_header_menuitem_color', true );
            $sticky_menuitem_hvrcolor = get_post_meta( $page_id, 'ninetheme_product_sticky_header_menuitem_hvrcolor', true );
            $sticky_svgicon_color     = get_post_meta( $page_id, 'ninetheme_product_sticky_header_svgicon_color', true );
            $sticky_counter_bgcolor   = get_post_meta( $page_id, 'ninetheme_product_sticky_header_counter_bgcolor', true );
            $sticky_counter_color     = get_post_meta( $page_id, 'ninetheme_product_sticky_header_counter_color', true );

            if ( $header_bgcolor ) {
                $theCSS .= '.single-product.postid-'.$page_id.' header.ninetheme-header-default {
                    background-color:'.esc_url( $header_bgcolor ).'!important;
                }';
            }
            if ( $menuitem_color ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-header-top-menu-area>ul>li.menu-item>a,
                .single-product.postid-'.$page_id.' .ninetheme-header-top-menu-area ul li .submenu>li.menu-item>a {
                    color:'.esc_url( $menuitem_color ).'!important;
                }';
            }
            if ( $menuitem_hvrcolor ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-header-top-menu-area>ul>li.menu-item>a:hover,
                .single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-header-top-menu-area ul li .submenu>li.menu-item>a:hover,
                .single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-header-top-menu-area>ul>li.menu-item.active>a,
                .single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-header-top-menu-area ul li .submenu>li.menu-item.active>a {
                    color:'.esc_url( $menuitem_hvrcolor ).'!important;
                }';
            }
            if ( $svgicon_color ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-svg-icon {
                    fill:'.esc_url( $svgicon_color ).'!important;
                    color:'.esc_url( $svgicon_color ).'!important;
                }';
            }
            if ( $counter_bgcolor ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-wc-count {
                    background-color:'.esc_url( $counter_bgcolor ).'!important;
                }';
            }
            if ( $counter_color ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default .ninetheme-wc-count {
                    color:'.esc_url( $counter_color ).'!important;
                }';
            }
            if ( $sticky_header_bgcolor ) {
                $theCSS .= '.single-product.postid-'.$page_id.' header.ninetheme-header-default.sticky-start {
                    background-color:'.esc_url( $sticky_header_bgcolor ).'!important;
                }';
            }
            if ( $sticky_menuitem_color ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-header-top-menu-area>ul>li.menu-item>a,
                .single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-header-top-menu-area ul li .submenu>li.menu-item>a {
                    color:'.esc_url( $sticky_menuitem_color ).'!important;
                }';
            }
            if ( $sticky_menuitem_hvrcolor ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-header-top-menu-area>ul>li.menu-item>a:hover,
                .single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-header-top-menu-area ul li .submenu>li.menu-item>a:hover,
                .single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-header-top-menu-area>ul>li.menu-item.active>a,
                .single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-header-top-menu-area ul li .submenu>li.menu-item.active>a {
                    color:'.esc_url( $sticky_menuitem_hvrcolor ).'!important;
                }';
            }
            if ( $sticky_svgicon_color ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-svg-icon {
                    fill:'.esc_url( $sticky_svgicon_color ).'!important;
                    color:'.esc_url( $sticky_svgicon_color ).'!important;
                }';
            }
            if ( $sticky_counter_bgcolor ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-wc-count {
                    background-color:'.esc_url( $sticky_counter_bgcolor ).'!important;
                }';
            }
            if ( $sticky_counter_color ) {
                $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-header-default.sticky-start .ninetheme-wc-count {
                    color:'.esc_url( $sticky_counter_color ).'!important;
                }';
            }
        }

        $progressbar_wrapper_brd_radius = ninetheme_settings( 'product_progressbar_wrapper_brd_radius', '' );
        if ( $progressbar_wrapper_brd_radius ) {
            $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-product-summary .ninetheme-summary-item.ninetheme-single-product-stock {
                -webkit-border-radius:'.esc_url( $progressbar_wrapper_brd_radius ).'px;
                -moz-border-radius:'.esc_url( $progressbar_wrapper_brd_radius ).'px;
                border-radius:'.esc_url( $progressbar_wrapper_brd_radius ).'px;
            }';
        }
        $progressbar_brd_radius = ninetheme_settings( 'product_progressbar_brd_radius', '' );
        if ( $progressbar_brd_radius ) {
            $theCSS .= '.single-product.postid-'.$page_id.' .ninetheme-single-product-stock .ninetheme-product-stock-progress,.single-product.postid-'.$page_id.' .ninetheme-single-product-stock .ninetheme-product-stock-progressbar {
                -webkit-border-radius:'.esc_url( $progressbar_brd_radius ).'px;
                -moz-border-radius:'.esc_url( $progressbar_brd_radius ).'px;
                border-radius:'.esc_url( $progressbar_brd_radius ).'px;
            }';
        }

        $share_shape_type       = ninetheme_settings( 'single_shop_share_shape_type', '' );
        $active_tab             = ninetheme_settings( 'product_tabs_active_tab', '' );
        $terms_shape            = ninetheme_settings( 'variations_terms_shape', '' );
        $terms_brd_radius       = ninetheme_settings( 'selected_variations_terms_brd_radius', '' );
        $disabled_terms_opacity = ninetheme_settings( 'product_attr_term_inactive_opacity', '' );
        $tabs_custom_order      = ninetheme_settings( 'product_tabs_custom_order', '0' );
        $tabs_order             = ninetheme_settings( 'product_tabs_order', null );
        $popups_sec_rad         = ninetheme_settings( 'product_popups_section_brd_radius', '' );
        $popups_sale_rad        = ninetheme_settings( 'product_labels_sale_radius', '' );
        $popups_discount_rad    = ninetheme_settings( 'product_labels_discount_radius', '' );
        $checked_terms_icon     = ninetheme_settings( 'variations_terms_checked_closed_icon_visibility', '1' );
        $loading_color          = ninetheme_settings( 'product_addtocart_loading_color' );
        $loading_color2         = ninetheme_settings( 'product_addtocart_loading_color2' );

        if ( 'square' == $share_shape_type ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-product-summary .ninetheme-social-icons a { border-radius: 0; }';
        }
        if ( 'round' == $share_shape_type ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-product-summary .ninetheme-social-icons a { border-radius: 4px; }';
        }
        if ( 'round' == $share_shape_type ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-product-summary .ninetheme-social-icons a { border-radius: 4px; }';
        }
        if ( $terms_brd_radius ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-selected-variations-terms-wrapper .ninetheme-selected-variations-terms { border-radius:'.esc_attr( $terms_brd_radius ).'px; }';
        }
        if ( 'cicle' == $terms_shape ) {
            $theCSS .= '.ninetheme-terms.ninetheme-type-color .ninetheme-term-wrapper,.ninetheme-terms.ninetheme-type-color .ninetheme-term,.ninetheme-terms.ninetheme-type-image .ninetheme-term,.ninetheme-terms.ninetheme-type-button .ninetheme-term:after{ border-radius: 100%;}';
        }
        if ( 'square' == $terms_shape ) {
            $theCSS .= '.ninetheme-terms.ninetheme-type-color .ninetheme-term-wrapper,.ninetheme-terms.ninetheme-type-color .ninetheme-term,.ninetheme-terms.ninetheme-type-image .ninetheme-term,.ninetheme-terms.ninetheme-type-button .ninetheme-term:after{ border-radius: 0;}';
        }
        if ( 'radius' == $terms_shape ) {
            $theCSS .= '.ninetheme-terms.ninetheme-type-color .ninetheme-term-wrapper,.ninetheme-terms.ninetheme-type-color .ninetheme-term,.ninetheme-terms.ninetheme-type-image .ninetheme-term,.ninetheme-terms.ninetheme-type-button .ninetheme-term:after{ border-radius: 3px;}';
        }
        if ( $disabled_terms_opacity ) {
            $theCSS .= '.ninetheme-terms.ninetheme-type-color .ninetheme-term.ninetheme-disabled,.ninetheme-terms.ninetheme-type-image .ninetheme-term.ninetheme-disabled,.ninetheme-terms.ninetheme-type-button .ninetheme-term.ninetheme-disabled:after{ opacity:'.$disabled_terms_opacity.';}';
        }
        if ( '0' == $checked_terms_icon ) {
            $theCSS .= '.ninetheme-variations .ninetheme-terms .ninetheme-term.ninetheme-selected:before { display:none;}';
        }
        if ( $active_tab != '' && $active_tab != 'all' ) {
            $theCSS .= '.ninetheme-product-accordion-wrapper .ninetheme-accordion-item'.$active_tab.' .ninetheme-accordion-body { display: block; }';
        }
        if ( $active_tab == 'all' ) {
            $theCSS .= '.ninetheme-product-accordion-wrapper .ninetheme-accordion-item .ninetheme-accordion-body { display: block; }';

        }
        if ( $tabs_custom_order == '1' ) {
            if ( !empty( $tabs_order['show'] ) ) {
                $theCSS .= '.ninetheme-product-accordion-wrapper { display: flex; flex-direction: column;}';
            }
        }
        if ( $popups_sec_rad ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-product-summary .ninetheme-product-popup-details { border-radius:'.esc_attr( $popups_sec_rad ).'px; }';
        }
        if ( $popups_sale_rad ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-product-labels .ninetheme-label.ninetheme-badge { border-radius:'.esc_attr( $popups_sale_rad ).'px; }';
        }
        if ( $popups_discount_rad ) {
            $theCSS .= '.postid-'.$page_id.' .ninetheme-product-labels .ninetheme-label.ninetheme-discount { border-radius:'.esc_attr( $popups_discount_rad ).'px; }';
        }
        if ( $loading_color ) {
            $loading_color2 = $loading_color2 ? $loading_color2 : $loading_color;
            $theCSS .= '.ninetheme-product-summary .single_add_to_cart_button.ninetheme-btn.loading .loading-wrapper .ajax-loading, .ninetheme-product-summary .single_add_to_cart_button.ninetheme-btn .loading-wrapper .ajax-loading:before, .ninetheme-product-summary .single_add_to_cart_button.ninetheme-btn .loading-wrapper .ajax-loading:after{animation-name: dotFlashing2;background-color:'.$loading_color.';}';
            $theCSS .= '@keyframes dotFlashing2 {0% {background-color: '.$loading_color.';}50%,100% {background-color: '.$loading_color2.';}}';
        }

    }

    /*************************************************
    ## PAGE METABOX SETTINGS
    *************************************************/

    if ( is_page() && ! ninetheme_check_is_elementor() ) {

        $heroimg = wp_get_attachment_image_url( $page_id, 'full' );
        if ( $heroimg ) {
            $theCSS .= '.page-'.$page_id.' .breadcrumb-bg { background-image:url('.esc_url( $heroimg ).'); }';
        }
    }

    $extraCSS = '';
    $extraCSS = apply_filters( 'ninetheme_add_custom_css', $extraCSS );
    $theCSS .= $extraCSS;

    /* Add CSS to style.css */
    wp_register_style('ninetheme-custom-style', false);
    wp_enqueue_style('ninetheme-custom-style');
    wp_add_inline_style('ninetheme-custom-style', $theCSS );
}

add_action('wp_enqueue_scripts', 'ninetheme_custom_css', 99999999);


// customization on admin pages
function ninetheme_admin_custom_css()
{
    if ( ! is_admin() ) {
        return false;
    }

    /* CSS to output */
    $theCSS = '';

    $theCSS .= '
    #setting-error-tgmpa, #setting-error-crisop {
        display: block !important;
    }
    .menu-item.menu-item-depth-0 .et_menu_options .ninetheme-field-link-shortcode,
    .menu-item.menu-item-depth-0 .et_menu_options .ninetheme-field-link-hidetitle,
    .menu-item.menu-item-depth-0 .et_menu_options .ninetheme-field-link-title,
    .menu-item.menu-item-depth-0 .et_menu_options .ninetheme-field-link-label,
    .menu-item.menu-item-depth-0 .et_menu_options .ninetheme-field-link-labelcolor,
    .menu-item.menu-item-depth-0 .et_menu_options .ninetheme-field-link-image,
    .menu-item:not(.menu-item-depth-0) .et_menu_options .ninetheme-field-link-mega,
    .menu-item:not(.menu-item-depth-0) .et_menu_options .ninetheme-field-link-mega-columns{
        display: none;
    }
    .ninetheme_menu_options .small-tag {
        font-size: 10px;
        font-weight: 400;
        position: relative;
        top: -2px;
        display: inline-block;
        margin-left: 4px;
        color: #fff;
        background-color: #bbb;
        line-height: 1;
        padding: 3px 6px;
        border-radius: 3px;
    }
    .ninetheme-panel-heading {
        padding: 10px 12px;
        border-bottom: 1px solid #ddd;
    }
    .ninetheme-panel-subheading {
        padding: 0px 12px;
    }
    .ninetheme-panel-divider {
        margin: 10px 0;
        border-bottom: 1px solid #ddd;
        display: block;
    }
    .reduxd_field_th {
        color: #191919;
        font-weight: 700;
    }
    .redux-container .redux-main .form-table tr {
        position: relative;
    }
    .redux-container .redux-main .form-table tr.hide-field {
        position: relative;
        min-height: 40px;
    }
    .toggle-field {
        position: absolute;
        top: 10px;
        right: 0;
        display: flex;
        align-items: center;
        justify-content: center;
        width: 20px;
        height: 20px;
        cursor: pointer;
        background: #fff;
        border: 1px solid #7e8993;
    }
    .toggle-field.hide-field {
        background: #000;
        color: #fff;
    }
    .toggle-field.hide-field i {
        transform:rotate(180deg);
    }
    fieldset#ninetheme-shop_hero_custom_layout,
    fieldset#ninetheme-shop_loop_product_layouts {
        padding-right: 50px;
    }
    fieldset#shop_hero_custom_layout,
    fieldset#shop_loop_product_layouts {
        display: flex;
    }
    fieldset#shop_hero_custom_layout {
        flex-wrap: wrap;
    }
    fieldset#shop_hero_custom_layout ul{
        flex: auto;
        float: none;
        min-width: 200px;
        width: auto!important;
    }
    fieldset#shop_hero_custom_layout ul {
        min-width: auto;
    }
    @media screen and (max-width: 768px) {
        fieldset#shop_hero_custom_layout,
        fieldset#shop_loop_product_layouts {
            flex-wrap: wrap;
            flex-direction: column;
        }
        fieldset#shop_hero_custom_layout ul,
        fieldset#shop_loop_product_layouts ul#shop_loop_product_layouts_hide {
            margin-top: 15px!important;
        }
    }
    ul#shop_loop_product_layouts_hide .shop_loop_product_layouts_inner {
        max-height: 400px;
        overflow: auto;
        display: flex;
        flex-wrap: wrap;
    }
    .shop_loop_product_layouts_inner li {
        flex: auto;
        margin: 10px 5px 10px 5px;
    }
    .redux-container .redux-main #crisop-shop_product_type img {
        max-width: 190px;
    }
    .redux-container .redux-main #ninetheme-shop_product_type img {
        max-width: 175px!important;
    }
    #ninetheme-shop_product_type.redux-container-image_select ul.redux-image-select li {
        padding: 15px!important;
    }
    #ninetheme-shop_product_type.redux-container-image_select ul.redux-image-select{
        margin-left: -15px!important;
        margin-right: -15px!important;
    }
    .redux-group-tab .select2-container {
        max-width: calc(100% - 40px);
    }
    input#ninetheme_badge_color {
        margin: 0!important;
    }
    p.form-field.ninetheme_wc_cat_banner_field span {
        display: block;
        max-width: 95%;
    }
    td.ninetheme_cat_banner.column-ninetheme_cat_banner {
        position: relative;
    }
    .ninetheme_cat_banner span.wc-banner:before {
        font-family: Dashicons;
        font-weight: 400;
        text-transform: none;
        line-height: 1;
        -webkit-font-smoothing: antialiased;
        text-indent: 0px;
        color: #2271b1;
        content: "\f155";
        font-variant: normal;
        margin: 0px;
        font-size: 18px;
    }
    span.wc-banner {
        display: flex;
        align-items: center;
        justify-content: flex-start;
        width: 100%;
        height: 100%;
        position: absolute;
        top: 0;
        left: 25px;
        text-align: center;
    }
    .woocommerce_options_panel .ninetheme-color-field-wrapper .wp-picker-input-wrap label{
        margin: 0;
        width: auto;
    }
    .woocommerce_options_panel .ninetheme_product_badge_color_select,
    .woocommerce_options_panel .ninetheme-badge-title-field{
        margin-right: 15px;
        width: auto;
    }
    .woocommerce_options_panel .ninetheme_product_badge_color_select + .wp-picker-container.hidden{
        display: none!important;
    }
    .woocommerce_options_panel .ninetheme_product_badge_color_select option:hover{
        background-color: transparent!important;
    }
    .woocommerce_variable_attributes .min_max_rules_options {
        display: none;
    }
    .min_max_rules_options p.form-row.form-row-last {
        display: flex;
        flex-direction: column;
    }
    div#repeatable-fieldset-one label {
        float: none;
        margin: 0;
        margin-left: 12px;
        width: auto;
    }
    th#taxonomy-ninetheme_product_brands,th#woosw,
    th#taxonomy-ninetheme_product_campaigns,
    th#taxonomy-location {
        width: 11%!important;
    }
    .image-preview-wrapper {
        max-width: 100px;
    }
    .image-preview-wrapper img {
        max-width: 100%;
    }
    .redux-main .description {
        display: block;
        font-weight: normal;
    }
    li#toplevel_page_wpclever,
    #redux-connect-message {
        opacity: 0 !important;
        display: none !important;
        visibility : hidden;
    }
    .redux-main .wp-picker-container .wp-color-result-text {
        line-height: 28px;
    }
    .redux-container .redux-main .input-append .add-on,
    .redux-container .redux-main .input-prepend .add-on {
        line-height: 22px;
    }
  	#customize-controls img {
  		max-width: 75%;
  	}
    .redux-info-desc .thm-btn:hover {
        color: #000;
    }
    .redux-info-desc .thm-btn i {
        margin-left: 10px;
    }
    .redux-info-desc .thm-btn {
        -moz-user-select: none;
        border: medium none;
        border-radius: 4px;
        color: #fff;
        background-color: #2271b1;
        cursor: pointer;
        display: flex;
        justify-content: center;
        align-items: center;
        text-decoration: none;
        height: 40px;
        min-width: 160px;
        font-size: 14px;
        font-weight: 700;
        letter-spacing: 0;
        line-height: 1;
        margin-bottom: 0;
        text-align: center;
        text-transform: uppercase;
        touch-action: manipulation;
        transition: all 0.3s ease 0s;
        vertical-align: middle;
        white-space: nowrap;
    }
    ul#checkout_form_layouts_show,
    ul#checkout_form_layouts_hide {
        min-width: 250px;
    }
    .ninetheme-select2-wrapper + ul.select2-selection__rendered{
        display: none;
    }
    .ninetheme-column-item {
        display: inline-block;
        width: 40px;
        height: 40px;
        background-color: #eee;
        box-sizing: border-box;
        border: 1px solid #eee;
    }
    #ninetheme_swatches_image_thumbnail {
        float: left;
        margin-right: 10px;
    }
    #ninetheme_swatches_image_wrapper {
        line-height: 60px;
    }
    li.menu-item.mega-parent .ninetheme-field-link-label,
    li.menu-item.mega-parent .ninetheme-field-link-labelcolor,
    li.menu-item.mega-parent .ninetheme-field-link-image,
    li.menu-item:not(.menu-item-depth-0):not(.mega-parent) .ninetheme-field-link-mega,
    li.menu-item:not(.menu-item-depth-0) .ninetheme-field-link-mega-columns {
        display: none;
    }
    span.ninetheme-mega-menu-item-title,
    span.ninetheme-mega-column-menu-item-title {
        margin-left: 10px;
        padding: 2px 4px;
        background: #2271b1;
        color: #fff;
        line-height: 1;
        font-size: 9px;
    }
    .ninetheme-panel-subheading.menu-customize:not(.show_if_header_custom),
    .ninetheme_product_header_bgcolor_field:not(.show_if_header_custom),
    .ninetheme_product_header_menuitem_color_field:not(.show_if_header_custom),
    .ninetheme_product_header_menuitem_hvrcolor_field:not(.show_if_header_custom),
    .ninetheme_product_header_svgicon_color_field:not(.show_if_header_custom),
    .ninetheme_product_header_counter_bgcolor_field:not(.show_if_header_custom),
    .ninetheme_product_header_counter_color_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_type_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_bgcolor_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_menuitem_color_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_menuitem_hvrcolor_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_svgicon_color_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_counter_bgcolor_field:not(.show_if_header_custom),
    .ninetheme_product_sticky_header_counter_color_field:not(.show_if_header_custom) {
        display: none;
    }';
    // end $theCSS

    /* Add CSS to style.css */
    wp_register_style('ninetheme-admin-custom-style', false);
    wp_enqueue_style('ninetheme-admin-custom-style');
    wp_add_inline_style('ninetheme-admin-custom-style', $theCSS);
}
add_action('admin_enqueue_scripts', 'ninetheme_admin_custom_css');
