<?php

/*************************************************
## THEME DEFAULT HERO TEMPLATE
*************************************************/
if ( ! function_exists( 'ninetheme_hero_section' ) ) {

    function ninetheme_hero_section()
    {
        $h_t = get_the_title();
        $page_id = '';
        $h_bg = '';

        if ( is_404() ) {

            $name = 'error';
            $h_t  = esc_html__( 'Page Not Found', 'crisop' );

        } elseif ( is_archive() ) {

            $name = 'archive';
            $h_t  = get_the_archive_title();

        } elseif ( is_search() ) {

            $name = 'search';
            $h_t  = esc_html__( 'Search results for :', 'crisop' );

        } elseif ( is_home() || is_front_page() ) {

            $name = 'blog';
            $h_t  = esc_html__( 'Blog', 'crisop' );

        } elseif ( is_single() ) {

            $name = 'single';
            $h_t  = get_the_title();
            $h_bg = has_post_thumbnail() ? wp_get_attachment_url(get_post_thumbnail_id(), 'large') : '';

        } elseif ( is_page() ) {

            $name    = 'page';
            $h_t     = get_the_title();
            $page_id = 'page-'.get_the_ID();

        }

        do_action( 'ninetheme_before_page_hero' );

        if ( '0' != ninetheme_settings( $name.'_hero_visibility', '1' ) ) {
            ?>
            <div class="ninetheme-page-hero page-hero-big <?php echo esc_attr( $page_id ); ?>">
                <div class="container-xl ninetheme-container-xl">
                    <div class="row">
                        <div class="col-12">
                            <div class="ninetheme-page-hero-content ninetheme-flex ninetheme-align-center ninetheme-justify-center">
                                <?php

                                do_action( 'ninetheme_before_page_title' );

                                if ( !is_single() ) {
                                    if ( $h_t ) {

                                        printf( '<h2 class="nt-hero-title page-title mb-30">%s %s</h2>',
                                            wp_kses( $h_t, ninetheme_allowed_html() ),
                                            strlen( get_search_query() ) > 16 ? substr( get_search_query(), 0, 16 ).'...' : get_search_query()
                                        );

                                    } else {

                                        the_title('<h2 class="nt-hero-title page-title mb-10">', '</h2>');
                                    }
                                }

                                do_action( 'ninetheme_after_page_title' );

                                echo ninetheme_breadcrumbs();

                                ?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <?php
        }
        do_action( 'ninetheme_after_page_hero' );
    }
}
