<?php
/**
 * The Template for displaying product archives, including the main shop page which is a post type archive
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/archive-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce\Templates
 * @version 3.4.0
 */
if ( !ninetheme_is_pjax() ) {
    get_header();
}

if ( '1' == ninetheme_settings('shop_ajax_filter', '1' ) ) {
    wp_enqueue_script( 'pjax' );
    wp_enqueue_script( 'shopAjaxFilter' );
}

$pagination = apply_filters('ninetheme_shop_pagination_type', ninetheme_settings('shop_paginate_type') );
if ( $pagination == 'infinite' ) {
    wp_enqueue_script( 'ninetheme-infinite-scroll');
}

if ( $pagination == 'loadmore' ) {
    wp_enqueue_script( 'ninetheme-load-more');
}
?>

<div id="ninetheme-shop-page-elementor" class="ninetheme-shop-page-elementor">

    <?php echo ninetheme_print_elementor_templates( 'shop_elementor_template', '', true ); ?>

    <div class="shop-data-filters" data-shop-filters='<?php echo ninetheme_wc_filters_for_ajax(); ?>'></div>
</div>

<?php
if ( !ninetheme_is_pjax() ) {
    get_footer();
}
?>
