jQuery(document).ready(function($) {

    // AJax single add to cart
    if ( ninetheme_vars.shop_product_type === 'woo' ) {

        $(document.body).on('added_to_cart', function(data,fragments, cart_hash, btn){
            $.ajax({
                url        : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_ajax_add_to_cart' ),
                data       : data,
                type       : 'POST',
                processData: false,
                contentType: false,
                dataType   : 'json',
                success    : function( response ) {

                    var duration = ninetheme_vars.duration;

                    btn.closest('.ninetheme-product-loop-inner').removeClass('loading');

                    var fragments = response.fragments;
                    var appended  = '<div class="woocommerce-notices-wrapper">'+fragments.notices+'</div>';

                    $(appended).prependTo('.ninetheme-shop-popup-notices').delay(4000).fadeOut(300, function(){
                        $(this).remove();
                    });

                    // update other areas
                    $('.minicart-panel').replaceWith(fragments.minicart);
                    $('.ninetheme-cart-count').html(fragments.count);
                    $('.ninetheme-cart-total:not(.page-total)').html(fragments.total);

                    if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
                        $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                        $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                        if ( fragments.shipping.value >= 100 ) {
                            $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                        } else {
                            $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                        }
                    }

                    if ( ninetheme_vars.minicart_open === 'yes' ) {
                        $('html,body').addClass('ninetheme-overlay-open');
                        $('.ninetheme-side-panel,.panel-content .cart-area').addClass('active');
                    }
                },
                error: function() {
                    $( document.body ).trigger( 'wc_fragments_ajax_error' );
                }
            });
        });
    }

    $(document).on('click', 'a.ninetheme_ajax_add_to_cart', function(e){
        e.preventDefault();

        if ( ninetheme_vars.ajax_addtocart === 'no' ) {
            return;
        }

        var btn    = $(this),
            data   = new FormData(),
            qty    = parseFloat( btn.closest('.cart-quantity-wrapper').find('.qty').val() ),
            btnQty = parseFloat( btn.data('quantity') ),
            id     = btn.attr( 'data-product_id' );

        data.append('add-to-cart', id);

        qty = ( btnQty > 0 ) ? btnQty : 1;

        data.append('quantity', qty);

        btn.addClass('loading');

        $.ajax({
            url        : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_ajax_add_to_cart' ),
            data       : data,
            type       : 'POST',
            processData: false,
            contentType: false,
            dataType   : 'json',
            success    : function( response ) {

                btn.removeClass('loading').addClass('added');
                btn.parent().addClass('added');

                var fragments = response.fragments;
                var appended  = '<div class="woocommerce-notices-wrapper">'+fragments.notices+'</div>';

                $(appended).prependTo('.ninetheme-shop-popup-notices').delay(4000).fadeOut(300, function(){
                    $(this).remove();
                });

                // update other areas
                $('.minicart-panel').replaceWith(fragments.minicart);
                $('.ninetheme-cart-count').html(fragments.count);
                $('.ninetheme-cart-total:not(.page-total)').html(fragments.total);

                if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
                    $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                    $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                    if ( fragments.shipping.value >= 100 ) {
                        $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                    } else {
                        $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                    }
                }

                var quantity = $('.ninetheme-side-panel .cart-quantity-wrapper[data-product_id="'+id+'"]').html();
                $('.ninetheme-loop-product .cart-quantity-wrapper[data-product_id="'+id+'"] .quantity').replaceWith(quantity);

                // Redirect to cart option
                if ( ninetheme_vars.cart_redirect === 'yes' ) {
                    window.location = ninetheme_vars.cart_url;
                    return;
                }

                if ( btn.closest('.has-qunatity').length>0 ) {
                    btn.closest('.has-qunatity').addClass('quantity-open');
                } else {
                    if ( btn.parent().hasClass('btn-type-icon') ) {
                        var cartUrl  = wc_add_to_cart_params.cart_url;
                        var btnUrl   = btn.attr('href');
                        var hintText = btn.siblings('.ninetheme-hint').text();
                        var viewCart = wc_add_to_cart_params.i18n_view_cart;

                        btn.removeClass('ninetheme_ajax_add_to_cart').addClass('url_replaced').attr('data-url',btnUrl).attr('href',cartUrl);
                        btn.siblings('.shopBag').hide();
                        btn.siblings('.ninetheme-hint').attr('data-title',hintText).text(viewCart);
                        btn.after( '<svg class="svgRight ninetheme-svg-icon" width="512" height="512" fill="currentColor" viewBox="0 0 128 128" enable-background="new 0 0 128 128" xmlns="http://www.w3.org/2000/svg"><path d="m64 0c-35.289 0-64 28.711-64 64s28.711 64 64 64 64-28.711 64-64-28.711-64-64-64zm0 120c-30.879 0-56-25.121-56-56s25.121-56 56-56 56 25.121 56 56-25.121 56-56 56zm26.828-58.828c1.563 1.563 1.563 4.094 0 5.656l-20 20c-.781.781-1.805 1.172-2.828 1.172s-2.047-.391-2.828-1.172c-1.563-1.563-1.563-4.094 0-5.656l13.172-13.172h-38.344c-2.209 0-4-1.789-4-4s1.791-4 4-4h38.344l-13.172-13.172c-1.563-1.563-1.563-4.094 0-5.656s4.094-1.563 5.656 0z"></path></svg>' );
                    }
                }

                if ( ninetheme_vars.minicart_open === 'yes' ) {
                    $('html,body').addClass('ninetheme-overlay-open');
                    $('.ninetheme-side-panel,.panel-content .cart-area').addClass('active');
                }
            },
            error: function() {
                $( document.body ).trigger( 'wc_fragments_ajax_error' );
            }
        });
    });

    $(document).on('click', '.cart-area .ninetheme_remove_from_cart_button', function(e){
        e.preventDefault();

        var $this = $(this),
            pid   = $this.data('product_id'),
            note  = ninetheme_vars.removed,
            cart  = $this.closest('.cart-area'),
            row   = $this.closest('.mini-cart-item'),
            name  = $this.data('product_name'),
            qty   = $(row).find('.cart-quantity').html(),
            msg   = qty ? qty+' &times '+name+' '+note : name+' '+note,
            btn   = $('.ninetheme_ajax_add_to_cart[data-product_id="'+pid+'"]');

        var appended = '<div class="woocommerce-notices-wrapper"><div class="woocommerce-message">'+msg+'</div></div>';

        $(appended).appendTo('.ninetheme-shop-popup-notices').delay(3000).fadeOut(300, function(){
            $(this).remove();
        });

        var addUrl   = btn.attr('data-url');
        var hintText = btn.siblings('.ninetheme-hint').attr('data-title');
        btn.siblings('.svgRight').remove();
        btn.siblings('.shopBag').show();
        btn.siblings('.ninetheme-hint').text(hintText);
        btn.addClass('ninetheme_ajax_add_to_cart').removeClass('url_replaced added').attr('href',addUrl);
        btn.parent().removeClass('added');
        btn.closest('.cart-quantity-wrapper').removeClass('quantity-open');
        cart.addClass('loading');

        row.remove();

        var cartItems = cart.find('.mini-cart-item').length;

        if ( cartItems == 0 ) {
            cart.addClass('no-products');
        }

        $.ajax({
            url      : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_remove_from_cart' ),
            type     : 'POST',
            dataType : 'json',
            data     : {
                cart_item_key : $(this).data( 'cart_item_key' ),
                id            : $(this).data( 'product_id' )
            },
            success : function(response) {
                console.log(response);
                cart.removeClass('loading no-products');

                var fragments = response.fragments;
-
                // update other areas
                $('.minicart-panel').replaceWith(fragments.minicart);
                $('.ninetheme-cart-count').html(fragments.count);
                $('.ninetheme-cart-total:not(.page-total)').html(fragments.total);

                if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
                    $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                    $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                    if ( fragments.shipping.value >= 100 ) {
                        $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                    } else {
                        $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                    }
                }

                $('.ninetheme-loop-product .cart-quantity-wrapper[data-product_id="'+pid+'"] .quantity').html('');

                $( document.body ).trigger( 'removed_from_cart', [ fragments, response.cart_hash, btn ] );

                if ( ninetheme_vars.is_cart == 'yes' && fragments.count == 0 ) {
                    location.reload(); // page reload
                }

                if ( ninetheme_vars.is_checkout == 'yes' && fragments.count == 0 ){
                    location.reload(); // page reload
                }
            },
            error: function() {
                $( document.body ).trigger( 'wc_fragments_ajax_error' );
            }
        });
    });

    $(document).on('click', '.ninetheme_clear_cart_button', function(e){
        var confirmMsg = ninetheme_vars.clear;
        if ( confirm( confirmMsg ) ){
            $.ajax({
                type     : 'POST',
                dataType : 'json',
                url      : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_clear_cart' ),
                data     : {
                    action : 'ninetheme_clear_cart'
                },
                success  : function ( response ) {

                    var fragments = response.fragments;
                    var message   = fragments.clear.msg;

                    if ( fragments.clear.status != 'success' ) {
                        alert(message);
                    } else {

                        var appended = '<div class="woocommerce-notices-wrapper"><div class="woocommerce-message">'+message+'</div></div>';
                        $(appended).appendTo('.ninetheme-shop-popup-notices').delay(3000).fadeOut(300, function(){
                            $(this).remove();
                        });

                        // update other areas
                        $('.minicart-panel').replaceWith(fragments.minicart);
                        $('.ninetheme-cart-count').html(fragments.count);
                        $('.ninetheme-cart-total:not(.page-total)').html(fragments.total);

                        if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
                            $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                            $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                            if ( fragments.shipping.value >= 100 ) {
                                $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                            } else {
                                $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                            }
                        }

                        location.reload(); // page reload

                        $(document.body).trigger('ninetheme_reset_all_cart_btn');
                    }
                }
            });
        }
    });
    $(document).on('click', '.product-remove .remove', function(e){
        var $this = $(this),
            pid   = $this.data('product_id');

        $( '.ninetheme-minicart .ninetheme_remove_from_cart_button[data-product_id="'+pid+'"]' ).trigger( 'click' );
    });

    $(document).on('updated_wc_div', function() {
        if ( ninetheme_vars.is_cart == 'yes' ) {
            $.ajax({
                url : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_ajax_add_to_cart' ),
                type: 'POST',
                data: {
                    action: 'ninetheme_ajax_add_to_cart'
                },
                success: function(response) {

                    var fragments = response.fragments;

                    $('.minicart-panel').replaceWith(fragments.minicart);
                    $('.ninetheme-cart-count').html(fragments.count);
                    $('.ninetheme-side-panel').attr('data-cart-count',fragments.count);
                    $('.ninetheme-cart-total:not(.page-total)').html(fragments.total);

                    if ( $('.ninetheme-cart-goal-text').length>0 ) {
                        $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                        $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                        if ( fragments.shipping.value >= 100 ) {
                            $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                        } else {
                            $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                        }
                    }
                }
            });
        }
    });
});
