jQuery(document).ready(function($) {
    "use strict";

    $(document).on('submit', '.woocommerce-form-login.ninetheme-ajax-login', function(event){
        event.preventDefault();

        var form     = $(this);
        var formData = form.serialize();
        var button   = form.find('button.woocommerce-form-login__submit');
        var data     = {
            cache      : false,
            type       : 'POST',
            action     : 'ninetheme_ajax_login',
            beforeSend : function() {
                button.addClass("loading").attr('disabled', true).append('<span class="spinner"></span>');
            },
            logindata  : formData
        };

        $.post(ninetheme_ajax_login.ajaxurl, data, function(response) {
            console.log(response);
            if ( response?.data?.redirecturl ) {
                $(".lost_password").hide();
                button.removeClass("loading").after('<ul class="woocommerce-message ninetheme-success" style="display:none;"><li>'+response.data.message+'</li></ul>');
                $( '.woocommerce-message.ninetheme-success' ).slideDown();
                window.location.href = response.data.redirecturl;
                return;
            }

            // Remove notices from all sources
            $( '.woocommerce-error, .woocommerce-message' ).remove();
            button.removeClass("loading").attr('disabled', false).after('<ul class="woocommerce-error"><li>'+response.data+'</li></ul>');
        });

    });


    $(document).on('submit', '.woocommerce-form-register', function(event){
        event.preventDefault();

        var form     = $(this);
        var formData = form.serialize();
        var button   = form.find('button.woocommerce-form-register__submit');
        var data     = {
            cache      : false,
            type       : 'POST',
            action     : 'ninetheme_ajax_register',
            beforeSend : function() {
                button.addClass("loading").attr('disabled', true).append('<span class="spinner"></span>');
            },
            registerdata: formData
        };

        $.post(ninetheme_ajax_login.ajaxurl, data, function(response) {

            if( response?.data?.redirecturl ){
                button.removeClass("loading").after('<ul class="woocommerce-message ninetheme-success" style="display:none;"><li>'+response.data.message+'</li></ul>');
                $( '.woocommerce-message.ninetheme-success' ).slideDown();
                window.location.href = response.data.redirecturl;
                return;
            }

            // Remove notices from all sources
            $( '.woocommerce-error, .woocommerce-message' ).remove();
            button.removeClass("loading").attr('disabled', false).after('<ul class="woocommerce-error"><li>'+response.data+'</li></ul>');
        });
    });

});
