jQuery(document).ready(function($) {

    /*-- Strict mode enabled --*/
    'use strict';

    // quick shop start
    ninethemeQuickShopPopup();

    $(document.body).on('ninetheme_quick_shop', function(){
        //ninethemeQuickShopPopup();
    });

    $(document.body).on('wc_fragment_refresh', function(){
        //ninethemeQuickShopPopup();
    });

    $(document).on('ninethemeShopInit', function() {
        ninethemeQuickShopPopup();
    });

    function ninethemeQuickShopPopup(){

        if ( typeof ninetheme_vars !== 'undefined' && ninetheme_vars.quick_shop != 'yes' ) {
            return;
        }

       $( 'body' ).on('click touch', '.ninetheme-quick-shop-btn', function(event) {
            event.preventDefault();

            var $this = $(this),
                id    = $this.data('product_id');

            jQuery.magnificPopup.open({
                items           : {
                    src : ninetheme_vars.ajax_url + '?product_id=' + id
                },
                mainClass       : 'mfp-ninetheme-quickshop ninetheme-mfp-slide-bottom',
                removalDelay    : 160,
                overflowY       : 'scroll',
                fixedContentPos : false,
                closeBtnInside  : true,
                tClose          : '',
                closeMarkup     : '<div class="mfp-close ninetheme-panel-close-button"></div>',
                tLoading        : '<span class="loading-wrapper"><span class="ajax-loading"></span></span>',
                type            : 'ajax',
                ajax            : {
                    settings : {
                        type : 'GET',
                        data : {
                            action : 'ninetheme_ajax_quick_shop'
                        }
                    }
                },
                callbacks       : {
                    beforeOpen  : function() {},
                    open        : function() {
                        $('.mfp-preloader').addClass('loading');
                        //$('body').addClass('magnificpopupnoscroll');
                    },
                    ajaxContentAdded: function() {
                        $('.mfp-preloader').removeClass('loading');

                        var variations_form = $('.ninetheme-quickshop-wrapper').find('form.cart');
                        var termsWrapper    = $('.ninetheme-quickshop-wrapper').find('.ninetheme-selected-variations-terms-wrapper');

                        $(variations_form).wc_variation_form();

                        $(variations_form).on('show_variation', function( event, data ){
                            $('.ninetheme-quickshop-wrapper').find('.ninetheme-btn-reset-wrapper,.single_variation_wrap').addClass('active');
                        });
                        $(variations_form).on('hide_variation', function(){
                            $('.ninetheme-quickshop-wrapper').find('.ninetheme-btn-reset-wrapper,.single_variation_wrap').removeClass('active');
                        });

                        if ( $('.grouped_form').length>0 || $(variations_form).length>0 ) {
                            $(document.body).trigger('ninetheme_on_qtybtn');
                        }

                        if ( $('.ninetheme-selected-variations-terms-wrapper').length > 0 ) {
                            $(variations_form).on('change', function() {
                                var $this = $(this);
                                var selectedterms = '';
                                $this.find('.ninetheme-variations-items select').each(function(){
                                    var title = $(this).parents('.ninetheme-variations-items').find('.ninetheme-small-title').text();
                                    var val   = $(this).val();
                                    if (val) {
                                        selectedterms += '<span class="selected-features"><span class="selected-label">'+title+': </span><span class="selected-value">'+val+'</span></span>';
                                    }
                                });
                                if (selectedterms){
                                    termsWrapper.slideDown().find('.ninetheme-selected-variations-terms').html(selectedterms);
                                }
                            });
                        }

                        $('.ninetheme-quickshop-form-wrapper form.cart').submit(function(e) {

                            if ( $(e.originalEvent.submitter).hasClass('ninetheme-btn-buynow') ) {
                                return;
                            }

                            e.preventDefault();

                            var form = $(this),
                                btn  = form.find('.ninetheme-btn.single_add_to_cart_button'),
                                data = new FormData(form[0]),
                                val  = form.find('[name=add-to-cart]').val();

                            data.append('add-to-cart',val);

                            btn.addClass('loading');

                            $.ajax({
                                url         : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_ajax_add_to_cart' ),
                                data        : data,
                                type        : 'POST',
                                processData : false,
                                contentType : false,
                                dataType    : 'json',
                                success     : function( response ) {

                                    btn.removeClass('loading');

                                    if ( ! response ) {
                                        return;
                                    }

                                    var fragments = response.fragments;

                                    $('.ninetheme-quickshop-notices').html(fragments.notices).slideDown();

                                    // update other areas
                                    $('.minicart-panel').replaceWith(fragments.minicart);
                                    $('.ninetheme-cart-count').html(fragments.count);
                                    $('.ninetheme-cart-total').html(fragments.total);
                                    if ( $('.ninetheme-cart-goal-text').length ) {
                                        $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                                        $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                                    }

                                    if ( response.error && response.product_url ) {
                                        window.location = response.product_url;
                                        return;
                                    }

                                    $('.ninetheme-quickshop-notices .close-error').on('click touch', function(e) {
                                        $('.ninetheme-quickshop-notices').slideUp();
                                    });

                                    $('.ninetheme-quickshop-wrapper .ninetheme-btn-reset,.ninetheme-quickshop-wrapper .plus,.ninetheme-quickshop-wrapper .minus').on('click touch', function(event) {
                                        $('.ninetheme-quickshop-notices').slideUp();
                                    });

                                    $('.ninetheme-quickshop-buttons-wrapper').slideDown().addClass('active');

                                    $('.ninetheme-quickshop-buttons-wrapper .ninetheme-btn').on('click touch', function(e) {
                                        if ( $(this).hasClass('open-cart-panel') ) {
                                            $('html,body').addClass('ninetheme-overlay-open');
                                            $('.ninetheme-side-panel .active').removeClass('active');
                                            $('.ninetheme-side-panel').addClass('active');
                                            $('.cart-area').addClass('active');
                                        }
                                        $.magnificPopup.close();
                                    });
                                }
                            });

                        });

                        $('body').on('click', '.ninetheme-btn-buynow', function() {
                            if ($(this).parents('form.cart').length) {
                                return;
                            }
                            $('form.cart').find('.ninetheme-btn-buynow').trigger('click');
                        });
                    },
                    beforeClose : function() {},
                    close : function() {
                        //$('body').removeClass('magnificpopupnoscroll');
                    },
                    afterClose : function() {}
                }
            });
        });
    }
    // quick shop end

});
