jQuery(document).ready(function ($) {

    $(document).on('ninethemeShopInit', function () {
        infinitescroll();
    });

    function infinitescroll() {

        $(window).data('ajaxready', true).scroll(function(e) {

            if ($(window).data('ajaxready') == false) return;
            if ($('div.ninetheme-products').hasClass('all-products-loaded') ) return;
            var products_row  = $('div.ninetheme-products').offset().top + $('div.ninetheme-products.row').outerHeight();
            var products_rowh = $('div.ninetheme-products.row').outerHeight();
            if( $(window).scrollTop() >= ( products_row - window.innerHeight ) - products_rowh ) {

                $(window).data('ajaxready', false);

                ninetheme_infinite_pagination();
            }
        });
    }

    infinitescroll();

    function ninetheme_infinite_pagination() {
        var obj = $('.shop-data-filters').data('shop-filters');
        if ( !obj ) {
            return;
        }
        var data = {
            cache      : false,
            action     : 'ninetheme_shop_load_more',
            beforeSend : function() {

                if ( obj.current_page == obj.max_page ) {
                    $('.ninetheme-load-more').removeClass('content-loading').addClass('no-more').text(obj.no_more);
                    setTimeout(function(){
                        $('.row-infinite').slideUp('slow');
                    }, 3000);
                } else {
                    $('.row-infinite').show();
                    $('.ninetheme-load-more').addClass('loading');
                }
            },
            'ajaxurl'         : obj.ajaxurl,
            'current_page'    : obj.current_page,
            'per_page'        : obj.per_page,
            'max_page'        : obj.max_page,
            'cat_id'          : obj.cat_id,
            'brand_id'        : obj.brand_id,
            'campaign_id'     : obj.campaign_id,
            'locations'       : obj.locations,
            'filter_cat'      : obj.filter_cat,
            'filter_brand'    : obj.filter_brand,
            'filter_campaign' : obj.filter_campaign,
            'layered_nav'     : obj.layered_nav,
            'on_sale'         : obj.on_sale,
            'in_stock'        : obj.in_stock,
            'orderby'         : obj.orderby,
            'min_price'       : obj.min_price,
            'max_price'       : obj.max_price,
            'product_style'   : obj.product_style,
            'column'          : obj.column,
            'no_more'         : obj.no_more,
            'is_search'       : obj.is_search,
            'is_shop'         : obj.is_shop,
            'is_brand'        : obj.is_brand,
            'is_cat'          : obj.is_cat,
            'is_tag'          : obj.is_tag,
            's'               : obj.s
        };

        if ( obj.current_page == obj.max_page ) {
            $('.ninetheme-load-more').addClass('no-more').text(obj.no_more);
            $('.row-infinite').slideDown('slow');
            setTimeout(function(){
                $('.row-infinite').slideUp('slow');
            }, 3000);
            return;
        }

        $.post(obj.ajaxurl, data, function(response) {
            if ( response != '0' ) {
                $('div.ninetheme-products.row').append(response);
            }

            $(document.body).trigger('ninetheme_quick_shop');
            $('body').trigger('ninetheme_quick_init');
            $(document.body).trigger('ninetheme_variations_init');

            if ( obj.current_page == obj.max_page ) {

                $('.ninetheme-load-more').addClass('no-more').text(obj.no_more);
                setTimeout(function(){
                    $('.row-infinite').slideUp('slow');
                }, 3000);
                $('div.ninetheme-products').addClass('all-products-loaded');
            }

            $(document.body).trigger('ninetheme_masonry_init');
            $(document.body).trigger('ninetheme_loop_product_details_init');

            obj.current_page++;

            $(window).data('ajaxready', true);
        });

        return false;
    }
});
