jQuery(document).ready(function($) {
    "use strict";

    function scrollToTop($target) {
        if ( $($target).length ) {
            var adminBarHeight = $body.hasClass('admin-bar') ? 46 + 140 : 140;
            setTimeout(function(){
                $('html, body').stop().animate({
                    scrollTop: $($target).offset().top - adminBarHeight
                }, 800);
            }, 800 );

        }
    }

    $(document).on('click', '.ninetheme-load-more', function(event){

        event.preventDefault();
        var loading = $('.ninetheme-load-more').data('title');
        var more    = $('.ninetheme-load-more').text();
        var obj     = $('.shop-data-filters').data('shop-filters');

        var data = {
            cache      : false,
            action     : 'ninetheme_shop_load_more',
            beforeSend : function() {
                $('.ninetheme-load-more').html(loading).addClass('loading');
            },
            'ajaxurl'         : obj.ajaxurl,
            'current_page'    : obj.current_page,
            'max_page'        : obj.max_page,
            'per_page'        : obj.per_page,
            'layered_nav'     : obj.layered_nav,
            'cat_id'          : obj.cat_id,
            'campaign_id'     : obj.campaign_id,
            'brand_id'        : obj.brand_id,
            'locations'       : obj.locations,
            'filter_cat'      : obj.filter_cat,
            'filter_brand'    : obj.filter_brand,
            'filter_campaign' : obj.filter_campaign,
            'on_sale'         : obj.on_sale,
            'in_stock'        : obj.in_stock,
            'orderby'         : obj.orderby,
            'min_price'       : obj.min_price,
            'max_price'       : obj.max_price,
            'product_style'   : obj.product_style,
            'column'          : obj.column,
            'no_more'         : obj.no_more,
            'is_search'       : obj.is_search,
            'is_shop'         : obj.is_shop,
            'is_brand'        : obj.is_brand,
            'is_cat'          : obj.is_cat,
            'is_tag'          : obj.is_tag,
            's'               : obj.s
        };
        // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
        $.post(obj.ajaxurl, data, function(response) {

            if ( response != '0' ) {
                $('div.ninetheme-products.row').append(response);
            }

            obj.current_page++;

            $('.ninetheme-load-more').html(more).removeClass('loading');

            if ( obj.current_page == obj.max_page ) {
                $('.ninetheme-more').remove();
            }

            $(document.body).trigger('ninetheme_quick_shop');
            $('body').trigger('ninetheme_quick_init');
            $(document.body).trigger('ninetheme_variations_init');
            $(document.body).trigger('ninetheme_masonry_init');
            $(document.body).trigger('ninetheme_loop_product_details_init');
        });
    });
});
