jQuery(document).ready(function($) {

    /*-- Strict mode enabled --*/
    'use strict';

    var scrollOffset = $('.ninetheme-header-default').height();

    if ( $('body').hasClass('admin-bar') ) {
        scrollOffset = scrollOffset + 32;
    }

    if ( $('.woocommerce-product-gallery__trigger').length>0 ) {
        var topPos = $('.flex-viewport').position();
        $('.woocommerce-product-gallery__trigger').appendTo('.flex-viewport');
    }

    if ( $('[data-fancybox="gallery"]').length > 0 ) {
        Fancybox.bind('[data-fancybox="gallery"]', {
            showClass : 'fancybox-zoomInUp',
            hideClass : 'fancybox-zoomOutDown',
            animated  : true,
            groupAll  : true
        });
    }


    if ( $(".ninetheme-product-stock-progressbar").length ) {
        var percent = $(".ninetheme-product-stock-progressbar").data('stock-percent');
        $(".ninetheme-product-stock-progressbar").css('width',percent);
    }

    // single page ajax add to cart
    if ( ninetheme_vars.product_ajax == 'yes' ) {
        $('body').on('submit', '.nt-woo-single form.cart', function(e) {

            if ( $(this).parents('.product').hasClass('product-type-external') || $(e.originalEvent.submitter).hasClass('ninetheme-btn-buynow') ) {
                return;
            }

            e.preventDefault();

            var form = $(this),
                btn  = form.find('.ninetheme-btn.single_add_to_cart_button');
                data = new FormData(form[0]);

            btn.addClass('loading');

            data.append('add-to-cart', form.find('[name=add-to-cart]').val() );

            // Ajax action.
            $.ajax({
                url         : ninetheme_vars.wc_ajax_url.toString().replace( '%%endpoint%%', 'ninetheme_ajax_add_to_cart' ),
                data        : data,
                type        : 'POST',
                processData : false,
                contentType : false,
                dataType    : 'json',
                success     : function( response ) {

                    btn.removeClass('loading');

                    var fragments = response.fragments;
                    var appended  = '<div class="woocommerce-notices-wrapper">'+fragments.notices+'</div>';

                    if ( fragments.notices.indexOf('woocommerce-error') > -1 ) {

                        btn.addClass('disabled');
                        $(appended).prependTo('.ninetheme-shop-popup-notices');

                    } else {

                        if ( $('.ninetheme-side-panel').length>0 && ninetheme_vars.minicart_open === 'yes' ) {
                            if ( !(form.parents('.ninetheme-quickshop-wrapper').length>0) ) {
                                $('html,body').addClass('ninetheme-overlay-open');
                                $('.panel-header-actions .active,.panel-content .active').removeClass('active');
                                $('.ninetheme-side-panel,.panel-content .cart-area').addClass('active');
                                $('.ninetheme-header-overlay').addClass('close-cursor');
                            }
                        }

                        if ( $('.ninetheme-shop-popup-notices .woocommerce-notices-wrapper').length>0 ) {
                            $('.ninetheme-shop-popup-notices .woocommerce-notices-wrapper').remove();
                            $(appended).prependTo('.ninetheme-shop-popup-notices').delay(4000).fadeOut(300, function(){
                                $(this).remove();
                            });
                        } else {
                            $(appended).prependTo('.ninetheme-shop-popup-notices').delay(4000).fadeOut(300, function(){
                                $(this).remove();
                            });
                        }
                    }

                    // update other areas
                    $('.minicart-panel').replaceWith(fragments.minicart);
                    $('.ninetheme-cart-count').html(fragments.count);
                    $('.ninetheme-cart-total').html(fragments.total);

                    if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
                        $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                        $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                        if ( fragments.shipping.value >= 100 ) {
                            $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                        } else {
                            $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                        }
                    }

                    // Redirect to cart option
                    if ( wc_add_to_cart_params.cart_redirect_after_add === 'yes' ) {
                        window.location = wc_add_to_cart_params.cart_url;
                        return;
                    }
                },
                error: function() {
                    btn.removeClass('loading');
                    console.log('cart-error');
                    $( document.body ).trigger( 'wc_fragments_ajax_error' );
                }
            });
        });
    }

    $('body').on('click', '.ninetheme-btn-buynow', function() {
        if ($(this).parents('form.cart').length) {
            return;
        }
        $('form.cart').find('.ninetheme-btn-buynow').trigger('click');
    });

    // product selected-variations-terms
    if ( $('.ninetheme-selected-variations-terms-wrapper').length > 0 ) {
        $('.variations_form').on('change', function() {
            var $this = $(this);
            var selectedterms = '';
            $this.find('.ninetheme-variations-items select').each(function(){
                var title = $(this).parents('.ninetheme-variations-items').find('.ninetheme-small-title').text();
                var val = $(this).val();
                if (val) {
                    selectedterms += '<span class="selected-features"><span class="selected-label">'+title+': </span><span class="selected-value">'+val+'</span></span>';
                }
            });
            if (selectedterms){
                $('.ninetheme-selected-variations-terms-wrapper').slideDown().find('.ninetheme-selected-variations-terms').html(selectedterms);
            }
        });
        $('.ninetheme-btn-reset.reset_variations').on('click', function() {
            $('.ninetheme-selected-variations-terms-wrapper').slideUp();
        });
    }

    var viewingItem = $('.ninetheme-product-view'),
        data        = viewingItem.data('product-view'),
        countView   = viewingItem.find('.ninetheme-view-count'),
        current     = 0,
        change_counter;

    function singleProductFakeView() {

        if ( viewingItem.length ) {
            var min    = data.min,
                max    = data.max,
                delay  = data.delay,
                change = data.change,
                id     = data.id;

            if ( !viewingItem.hasClass( 'inited' ) ) {
                if ( typeof change !== 'undefined' && change ) {
                    clearInterval( change );
                }

                current = $.cookie( 'ninetheme_cpv_' + id );

                if ( typeof current === 'undefined' || !current ) {
                    current = Math.floor(Math.random() * max) + min;
                }

                viewingItem.addClass('inited');

                $.cookie('ninetheme_cpv_' + id, current, { expires: 1 / 24, path: '/'} );

                countView.html( current );

            }

            change_counter = setInterval( function() {
                current    = parseInt( countView.text() );

                if ( !current ) {
                    current = min;
                }

                var pm = Math.floor( Math.random() * 2 );
                var others = Math.floor( Math.random() * change + 1 );
                current = ( pm < 1 && current > others ) ? current - others : current + others;
                $.cookie('ninetheme_cpv_' + id, current, { expires: 1 / 24, path: '/'} );

                countView.html( current );

            }, delay);
        }
    }

    singleProductFakeView();

    /**
    * scrollToTop
    */
    function scrollToTop(target,delay,timeout) {
        setTimeout(function(){
            $('html, body').stop().animate({
                scrollTop: target.offset().top - scrollOffset
            }, delay);
        }, timeout );
    }

    ninethemeProductGalleryInit();

    function ninethemeProductGalleryInit() {
        if ( $('.ninetheme-product-gallery-main-slider').length ) {
            var thumbsDirection = 'horizontal';
            if ( $('.ninetheme-swiper-slider-wrapper').hasClass('ninetheme-slider-thumbs-right') || $('.ninetheme-swiper-slider-wrapper').hasClass('ninetheme-slider-thumbs-left') ) {
                var thumbsDirection = 'vertical';
            }
            $('.ninetheme-product-gallery-main-slider .swiper-slide').each(function(i,e){
                var $this    = $(this);
                var thumbUrl = $this.data('src');
                var active   = i == 0 ? ' swiper-slide-thumb-active' : '';
                var tumbImg  = $this.hasClass('iframe-video') ? '<i class="fa fa-play"></i>' : '<img src="'+thumbUrl+'">';
                $('<div class="swiper-slide'+active+'">'+tumbImg+'</div>').appendTo($('.ninetheme-product-thumbnails .swiper-wrapper'));
            });

            var galleryThumbs  = new NTSwiper( '.ninetheme-product-thumbnails', {
                spaceBetween         : 10,
                slidesPerView        : 5,
                direction            : "horizontal",
                watchOverflow        : true,
                watchSlidesProgress  : true,
                watchSlidesVisibility: true,
                rewind               : true,
                resizeObserver       : true,
                grabCursor           : true,
                breakpoints          : {
                    320 : {
                        slidesPerView : 5,
                        direction     : "horizontal"
                    },
                    576 : {
                        slidesPerView : 8,
                        direction     : "horizontal",
                    },
                    768 : {
                        slidesPerView : thumbsDirection == 'vertical' ? 'auto' : 8,
                        direction     : thumbsDirection
                    }
                },
                on                   : {
                    resize : function ( swiper ) {
                        swiper.update();
                        var videoicon = $('.ninetheme-product-thumbnails .swiper-slide:not(.swiper-slide-active)').height();
                        $('.ninetheme-slide-video-item-icon').css('height', videoicon );
                    },
                    init : function ( swiper ) {
                        var videoicon = $('.ninetheme-product-thumbnails .swiper-slide:not(.swiper-slide-active)').height();
                        $('.ninetheme-slide-video-item-icon').css('height', videoicon );
                    }
                }
            });

            var galleryMain = new NTSwiper( '.ninetheme-product-gallery-main-slider', {
                speed                 : 800,
                spaceBetween          : 0,
                slidesPerView         : 1,
                direction             : "horizontal",
                watchSlidesVisibility : true,
                watchSlidesProgress   : true,
                rewind                : true,
                resizeObserver        : true,
                grabCursor            : true,
                navigation            : {
                    nextEl : ".ninetheme-product-gallery-main-slider .ninetheme-swiper-next",
                    prevEl : ".ninetheme-product-gallery-main-slider .ninetheme-swiper-prev"
                },
                thumbs                : {
                    swiper: galleryThumbs
                },
                on                    : {
                    init : function ( swiper ) {
                        var heightVertical = $('.ninetheme-product-gallery-main-slider').height();
                        $('.ninetheme-product-thumbnails').css('max-height', heightVertical );
                    },
                    resize : function ( swiper ) {
                        var heightVertical = $('.ninetheme-product-gallery-main-slider').height();
                        $('.ninetheme-product-thumbnails').css('max-height', heightVertical );
                        swiper.update();
                    },
                    transitionEnd : function ( swiper ) {
                        var  active = swiper.realIndex;

                        $( '.ninetheme-product-gallery-main-slider .swiper-slide:not(.swiper-slide-active)' ).each(function () {
                            var iframe = $( this ).find('iframe');
                            if ( iframe.length ) {
                                iframe[0].contentWindow.postMessage('{"event":"command","func":"' + 'pauseVideo' + '","args":""}', '*');
                            }
                        });

                        $( '.ninetheme-product-gallery-main-slider .swiper-slide.swiper-slide-active' ).each(function () {
                            var iframe2 = $( this ).find('iframe');
                            if ( iframe2.length ) {
                                iframe2[0].contentWindow.postMessage('{"event":"command","func":"' + 'playVideo' + '","args":""}', '*');
                            }
                        });
                    },
                    afterInit: function(swiper){
                        var iframesrc = $('.ninetheme-product-gallery-main-slider .iframe-video iframe').data('src');
                        $( '.ninetheme-product-gallery-main-slider .iframe-video iframe' ).attr('src', iframesrc);
                    }
                }
            });

            var $gallery     = $('.ninetheme-product-gallery-main-slider'),
                $mainImg     = $gallery.find('.ninetheme-swiper-slide-first'),
                $oMainImg    = $mainImg.find('img'),
                $oZoomImg    = $mainImg.find('img.zoomImg'),
                $oZoomSrc    = $oMainImg.attr('src'),
                $popupSrc    = $mainImg.attr('data-src'),
                $oThumbImg   = $('.ninetheme-product-thumbnails .swiper-slide:first-child img'),
                $hasThumbs   = $mainImg.attr('data-thumb') ? true : false,
                $oThumbSrc   = $hasThumbs ? $mainImg.attr('data-thumb') : $popupSrc,
                resetBtn     = $('.ninetheme-btn-reset.reset_variations'),
                $mainSkuHtml = $('.ninetheme-sku-wrapper .sku'),
                $mainSku     = $mainSkuHtml.html();


            $('.ninetheme-product-summary form.variations_form').on('show_variation', function( event, data ){
                if ( data.sku ) {
                    $mainSkuHtml.html(data.sku);
                }
                resetBtn.addClass( 'active' );
                var fullsrc = data.image.full_src;
                var src     = data.image.src;
                var tsrc    = data.image.gallery_thumbnail_src;
                $mainImg.attr('data-src',fullsrc);
                $oMainImg.attr('src',src);
                $oZoomImg.attr('src',fullsrc);
                if ( $hasThumbs ) {
                    $oThumbImg.attr('src',tsrc);
                } else {
                    $oThumbImg.attr('src',fullsrc);
                }
                setTimeout( function() {
                    if ( !$oMainImg.hasClass('active') ) {
                        galleryMain.slideTo(0);
                        galleryThumbs.slideTo(0);
                    }
                    galleryMain.update();
                    galleryMain.updateAutoHeight(10);
                    galleryThumbs.update();
                    initZoom('reinit',fullsrc);
                }, 100 );
            });

            $('.ninetheme-product-summary form.variations_form').on('hide_variation', function(){
                $mainSkuHtml.html($mainSku);
                resetBtn.removeClass( 'active' );
                $mainImg.attr('data-src',$popupSrc);
                $oMainImg.attr('src',$oZoomSrc);
                $oZoomImg.attr('src',$oZoomSrc);
                $oThumbImg.attr('src',$oThumbSrc);

                setTimeout( function() {
                    if ( !$oMainImg.hasClass('active') ) {
                        galleryMain.slideTo(0);
                        galleryThumbs.slideTo(0);
                    }
                    galleryMain.update();
                    galleryMain.updateAutoHeight(10);
                    galleryThumbs.update();
                    initZoom('reinit',$oZoomSrc);
                }, 100 );
            });


/*
            $( document ).on('change','.ninetheme-product-summary .variations_form select', function( e ) {
                var $this      = $(this),
                    $form      = $this.parents('.variations_form'),
                    variations = $form.data('product_variations'),
                    $oZoomImg  = $('.ninetheme-product-gallery-main-slider .ninetheme-swiper-slide-first img.zoomImg'),
                    gallery    = $('.ninetheme-product-gallery-main-slider');

                setTimeout( function() {
                    var current_id = $form.attr('current-image'),
                        image,
                        timage,
                        full_src,
                        src,
                        srcset,
                        sizes,
                        tsrc,
                        tsrcset,
                        tsizes;

                    $.map(variations, function(elementOfArray, indexInArray) {
                        if (elementOfArray.image_id == current_id) {
                            image   = elementOfArray.image;
                            src     = image.src;
                            full_src= image.full_src;
                            srcset  = image.srcset;
                            sizes   = image.sizes;
                        }
                    });
                    $.map(variations, function(elementOfArray, indexInArray) {
                        if (elementOfArray.image_id == current_id) {
                            timage  = elementOfArray.image;
                            tsrc    = timage.src;
                            tsrcset = timage.srcset;
                            tsizes  = timage.sizes;
                        }
                    });
                    if ( current_id ) {
                        $oMainImg.attr('src',src);
                        $oMainImg.attr('data-src',src);
                        $oZoomImg.attr('src',full_src);
                        if ( srcset ) {
                            $oMainImg.attr('srcset',srcset);
                        }
                        if ( sizes ) {
                            $oMainImg.attr('sizes',sizes);
                        }
                        $oThumbImg.attr('src',tsrc);
                        if ( tsrcset ) {
                            $oThumbImg.attr('srcset',tsrcset);
                        }
                        if ( tsizes ) {
                            $oThumbImg.attr('sizes',tsizes);
                        }

                        setTimeout( function() {
                            if ( !$oMainImg.hasClass('swiper-slide-active') ) {
                                galleryMain.slideTo(0);
                                galleryThumbs.slideTo(0);
                            }
                            galleryMain.update();
                            galleryMain.updateAutoHeight(10);
                            galleryThumbs.update();
                            initZoom('reinit',full_src);
                        }, 100 );

                        scrollToTop(gallery,300,300);
                    }
                }, 50 );
            });

            $( document ).on('click','.ninetheme-product-summary .reset_variations', function( e ) {
                var $form     = $(this).parents('.variations_form'),
                    gallery   = $('.ninetheme-product-gallery-main-slider'),
                    $oZoomImg = $('.ninetheme-product-gallery-main-slider .ninetheme-swiper-slide-first img.zoomImg');

                $oMainImg.attr('src',$oMainSrc);
                $oMainImg.attr('data-src',$oMainSrc);
                $oZoomImg.attr('src',$oZoomSrc);
                if ( $oMainSrcSet ) {
                    $oMainImg.attr('srcset',$oMainSrcSet);
                }
                if ( $oMainSrcSizes ) {
                    $oMainImg.attr('sizes',$oMainSrcSizes);
                }

                $oThumbImg.attr('src',$oThumbSrc);
                if ( $oThumbSrcSet ) {
                    $oThumbImg.attr('srcset',$oThumbSrcSet);
                }
                if ( $oThumbSrcSizes ) {
                    $oThumbImg.attr('sizes',$oThumbSrcSizes);
                }

                setTimeout( function() {
                    if ( !$oMainImg.hasClass('swiper-slide-active') ) {
                        galleryMain.slideTo(0);
                        galleryThumbs.slideTo(0);
                    }
                    galleryMain.update();
                    galleryMain.updateAutoHeight(10);
                    galleryThumbs.update();
                    initZoom('reinit',$oZoomSrc);
                }, 100 );

                scrollToTop(gallery,400,300);
            });
*/
            initZoom('load');

            /**
            * Init zoom.
            */
            function initZoom($action,$url) {
                if ( 'function' !== typeof $.fn.zoom && !wc_single_product_params.zoom_enabled ) {
                    return false;
                }

                var galleryWidth = $('.ninetheme-product-gallery-main-slider .swiper-slide').width(),
                    zoomEnabled  = false,
                    zoom_options = {
                        touch: false
                    };

                if ( 'ontouchstart' in document.documentElement ) {
                    zoom_options.on = 'click';
                }

                $('.ninetheme-product-gallery-main-slider .swiper-slide img').each( function( index, target ) {
                    var image = $( target );
                    var imageIndex = image.parents('.swiper-slide');

                    if ( image.attr( 'width' ) > galleryWidth ) {
                        if ( $action == 'load' ) {
                            zoom_options.url = image.parent().data('zoom-img');
                            image.wrap('<span class="ninetheme-zoom-wrapper" style="display:block"></span>')
                              .css('display', 'block')
                              .parent()
                              .zoom(zoom_options);
                        } else {
                            image.trigger('zoom.destroy').unwrap();
                            zoom_options.url = imageIndex.hasClass('ninetheme-swiper-slide-first') ? $url : image.parent().data('zoom-img');
                            image.wrap('<span class="ninetheme-zoom-wrapper" style="display:block"></span>')
                              .css('display', 'block')
                              .parent()
                              .zoom(zoom_options);
                        }
                    }
                });
            }
        }
    }

    var singlePopupCartHeight = $(".ninetheme-product-bottom-popup-cart").outerHeight();
    var singleCartPos = $('.ninetheme-product-summary .single_add_to_cart_button').offset();
    var singleCartTop = $('.ninetheme-product-summary .single_add_to_cart_button').length && $(".ninetheme-product-bottom-popup-cart").length ? singleCartPos.top : 0;
    var singleDocHeight = $(document).height() - singlePopupCartHeight;

    if ( $(".ninetheme-product-bottom-popup-cart").length && $(".ninetheme-product-summary .single_add_to_cart_button").length ) {
        $("body").css('padding-bottom',singlePopupCartHeight);
    }

    $(window).on("scroll", function () {

        if ( $(".ninetheme-product-bottom-popup-cart").length && $(".ninetheme-product-summary .single_add_to_cart_button").length ) {

            if ( $(window).scrollTop() > singleCartTop ) {
                $(".ninetheme-product-bottom-popup-cart").addClass('active');
                $("body").addClass('bottom-popup-cart-active');
            } else {
                $(".ninetheme-product-bottom-popup-cart").removeClass('active');
                $("body").removeClass('bottom-popup-cart-active');
            }
        }
    });

    if ( $('.pair-images-slider').length ) {
        $('.pair-images-slider').each(function () {
            const mySlider = new NTSwiper(this, {
                autoplay: true,
                speed: 400,
                slidesPerView: 1,
                breakpoints: {
                    // when window width is >= 320px
                    320: {
                        slidesPerView: 2,
                        spaceBetween: 5
                    },
                    // when window width is >= 480px
                    480: {
                        slidesPerView: 4,
                        spaceBetween: 5
                    },
                    // when window width is >= 768px
                    768: {
                        slidesPerView: 1
                    }
                }
            });
        });
    }

});
