jQuery(document).ready(function($) {

    "use strict";

    $('.product-in-cart .ninetheme-add-to-cart-btn').each(function() {
        $(this).addClass('added');
    });

    function ninethemeQtyBtn() {
        $('body').off('click.qtyBtn').on('click.qtyBtn','.plus, .minus', function(event) {
            event.preventDefault();
            var $this   = $(this),
                wrapper = $this.parents('.cart-quantity-wrapper'),
                pid     = wrapper.data('product_id'),
                qty     = $this.closest('.quantity').find('.qty'),
                val     = parseFloat( $(qty).val() ),
                max     = parseFloat( $(qty).attr('max') ),
                min     = parseFloat( $(qty).attr('min') ),
                step    = parseFloat( $(qty).attr('step') ),
                new_val = 0;

            if ( ! val || val === '' || val === 'NaN' ) {
                val = 0;
            }
            if ( max === '' || max === 'NaN' ) {
                max = '';
            }
            if ( min === '' || min === 'NaN' ) {
                min = 0;
            }
            if ( step === 'any' || step === '' || step === undefined || step === 'NaN' ) {
                step = 1;
            } else {
                step = step;
            }

            // Update values
            if ( $this.is( '.plus' ) ) {
                if ( max && ( max === val || val > max ) ) {
                    $(qty).val( max );
                    $this.addClass('disabled');
                } else {
                    $this.siblings('.minus').removeClass('disabled');
                    new_val = val + step;
                    $(qty).val( new_val );
                    if ( max && ( max === new_val || new_val > max ) ) {
                        $this.addClass('disabled');
                    }
                    $(qty).trigger('change');
                }
            } else {
                if ( min && ( min === val || val < min ) ) {
                    $(qty).val( min );
                    $this.addClass('disabled');
                } else if ( val > 0 ) {
                    new_val = val - step;
                    $(qty).val( new_val );
                    if ( min && ( min === new_val || new_val < min ) ) {
                        $this.addClass('disabled');
                    }
                    $(qty).trigger('change');
                }
            }

            $('.cart-update-button[name="update_cart"]').addClass('active');
            $this.closest('.ajax-quantity').addClass('active');
            $('.single_add_to_cart_button.disabled').removeClass('disabled');
            if ( $('.ninetheme-shop-popup-notices .woocommerce-error').length>0 ) {
                $('.ninetheme-shop-popup-notices .woocommerce-error').remove();
            }
        });
    }

    ninethemeQtyBtn();

    $(document.body).on('ninetheme_on_qtybtn', ninethemeQtyBtn );

    $(document.body).on( 'update_checkout', ninethemeQtyBtn );

    var timeout;

	$(document).on('change input', '.quantity .qty', function() {
		$('.cart-update-button[name="update_cart"]').addClass('active');

		$('.single_add_to_cart_button.disabled').removeClass('disabled');
		if ( $('.ninetheme-shop-popup-notices .woocommerce-error').length>0 ) {
			$('.ninetheme-shop-popup-notices .woocommerce-error').remove();
		}
	});

    $(document).on('change input', '.cart-quantity-wrapper .quantity .qty', function() {

        var input = $(this),
            qty   = input.val(),
            key   = input.parents('.cart-quantity-wrapper').data('key'),
            id    = input.parents('.cart-quantity-wrapper').data('product_id'),
            name  = input.parents('.woocommerce-mini-cart-item').find('.cart-name').html();

        if ( ninetheme_vars.is_cart == 'yes' ) {
            var referer = $('.ninetheme-cart-row .ninetheme-hidden input[name="_wp_http_referer"]');
        }
        if ( input.parents('.ninetheme-loop-product').length ) {
            name = input.parents('.ninetheme-loop-product').find('.ninetheme-loop-product-name').html();
        }
		if ( qty == '' ){
			return;
		}
        clearTimeout(timeout);

        timeout = setTimeout(function() {
            $.ajax({
                url     : ninetheme_vars.ajax_url,
                dataType: 'json',
                method  : 'GET',
                data    : {
                    action  : 'ninetheme_quantity_button',
                    id      : key,
                    qty     : qty,
                    is_cart : ninetheme_vars.is_cart
                },
                beforeSend  : function(){
                    if ( input.parents('.woocommerce-mini-cart-item').length ) {
                        input.parents('.woocommerce-mini-cart-item').addClass('loading').append('<span class="loading-wrapper"><span class="ajax-loading"></span></span>');
                    } else {
                        input.parents('.cart-quantity-wrapper').addClass('loading');
                    }
                },
                success : function(data) {
                    //console.log(data);
                    input.parents('.cart-quantity-wrapper').removeClass('loading');
                    if (data && data.fragments) {

                        var fragments = data.fragments;
                        var duration  = ninetheme_vars.notices_duration;

                        if ( fragments.count != 0 ) {
                            if ( qty == 0 ) {
                                var appended  = '<div class="woocommerce-notices-wrapper"><div class="woocommerce-message update-message"><span class="update">'+ninetheme_vars.updated+'</span> <strong>"'+name+'"</strong> '+ninetheme_vars.removed+'</div></div>';
                            } else {
                                var appended  = '<div class="woocommerce-notices-wrapper"><div class="woocommerce-message update-message"><span class="update">'+ninetheme_vars.updated+'</span>'+qty+'&times <strong>"'+name+'"</strong> '+ninetheme_vars.added+'</div></div>';
                            }
                        }

                        if ( fragments.count == 0 ) {
                            var appended  = '<div class="woocommerce-notices-wrapper"><div class="woocommerce-message update-message">'+fragments.update.msg+'</div></div>';
                        }

                        $(appended).prependTo('.ninetheme-shop-popup-notices').delay(duration).fadeOut(300, function(){
                            $(this).remove();
                        });

                        // update other areas
                        $('.minicart-panel').replaceWith(fragments.minicart);
                        $('.ninetheme-cart-count').html(fragments.count);
                        $('.ninetheme-side-panel').data('cart-count',fragments.count);
                        $('.ninetheme-cart-total:not(.page-total)').html(fragments.total);

                        if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
                            $('.ninetheme-cart-goal-text').html(fragments.shipping.message);
                            $('.ninetheme-progress-bar').css('width',fragments.shipping.value+'%');
                            if ( fragments.shipping.value >= 100 ) {
                                $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
                            } else {
                                $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
                            }
                        }

                        var quantity = $('.ninetheme-side-panel .cart-quantity-wrapper[data-product_id="'+id+'"]').html();
                        $('.ninetheme-loop-product .cart-quantity-wrapper[data-product_id="'+id+'"] .quantity').replaceWith(quantity);

                        $(document.body).trigger('ninetheme_update_minicart');

                        if ( ninetheme_vars.is_cart == 'yes' && fragments.count != 0  ) {
                            $('.ninetheme-cart-row').replaceWith(fragments.update.cart);
                            $('.ninetheme-cart-row .ninetheme-hidden input[name="_wp_http_referer"]').replaceWith(referer);
                        }

                        if ( $('.cross-sells .swiper-container').length>0 ) {
                            $('.swiper-container').each(function () {
                                const options  = $(this).data('swiper-options');
                                const mySlider = new NTSwiper(this, options );
                            });
                        }

                        if ( ninetheme_vars.is_cart == 'yes' && fragments.count == 0  ) {
                            location.reload(); // page reload
                        }

                        $(document.body).trigger('wc_fragment_refresh')
                    }
                },
                error: function() {
                    $( document.body ).trigger( 'wc_fragments_ajax_error' );
                }
            });
        }, 500);
    });

});
