(function($) {

    var $doc  = $(document),
        $win  = $(window),
        $body = $('body'),
        $prefix = '.ninetheme-shop-page-elementor ',
        links = $prefix+'.elementor-widget-wp-widget-woocommerce_product_tag_cloud a,';
        links += $prefix+'.wc-layered-nav-rating a,';
        links += $prefix+'.elementor-widget-wp-widget-woocommerce_product_categories a,';
        links += $prefix+'.woocommerce-widget-layered-nav-list a,';
        links += $prefix+'.ninetheme-woocommerce-pagination a,';
        links += $prefix+'.top-action a,';
        links += $prefix+'.ninetheme-choosen-filters a,';
        links += $prefix+'.widget_product_tag_cloud a,';
        links += $prefix+'.ninetheme-shop-filter-area a,';
        links += $prefix+'.ninetheme-woo-breadcrumb .breadcrumb li a,';
        links += $prefix+'.ninetheme-breadcrumbs li a,';
        links += $prefix+'.shop-slider-categories .slick-slide a,';
        links += $prefix+'.ninetheme-remove-filter a,';
        links += $prefix+'.ninetheme-product-status a,';
        links += $prefix+'.ninetheme-widget-product-categories a,';
        links += $prefix+'.ninetheme-widget-product-brands a,';
        links += $prefix+'.ninetheme-wc-category-list li a';
        links += $prefix+'.ninetheme-product-category-slider .ninetheme-category-item-inner a';

    function sortOrder() {
        var $order = $('.woocommerce-ordering');

        $order.on('change', 'select.orderby', function() {
            var $form = $(this).closest('form');
            $form.find('[name="_pjax"]').remove();

            $.pjax({
                container: '.ninetheme-shop-page-elementor',
                timeout  : 5000,
                url      : '?' + $form.serialize(),
                scrollTo : false,
                renderCallback: function(context, html, afterRender) {
                    context.html(html);
                    afterRender();
                    $doc.trigger('ninethemeShopInit');
                }
            });
        });

        $order.on('submit', function(e) {
            return false;
        });
    }

    function perPage() {
        var $perPage = $('.products-per-page');

        $perPage.on('change', 'select.perpage', function() {
            var $form = $(this).closest('form');
            $form.find('[name="_pjax"]').remove();

            $.pjax({
                container: '.ninetheme-shop-page-elementor',
                timeout  : 5000,
                url      : '?' + $form.serialize(),
                scrollTo : false,
                renderCallback: function(context, html, afterRender) {
                    context.html(html);
                    afterRender();
                    $doc.trigger('ninethemeShopInit');
                }
            });
        });

        $perPage.on('submit', function(e) {
            e.preventDefault(e);
        });
    }

    function priceSlider() {

        if ( $('body').hasClass('shop-layout-no-sidebar') || !$( '.price_slider' ).length > 0 ) {
            return;
        }

        $( document.body ).on( 'price_slider_create price_slider_slide', function( event, min, max ) {

            $( '.price_slider_amount span.from' ).html( accounting.formatMoney( min, {
                symbol:    woocommerce_price_slider_params.currency_format_symbol,
                decimal:   woocommerce_price_slider_params.currency_format_decimal_sep,
                thousand:  woocommerce_price_slider_params.currency_format_thousand_sep,
                precision: woocommerce_price_slider_params.currency_format_num_decimals,
                format:    woocommerce_price_slider_params.currency_format
            } ) );

            $( '.price_slider_amount span.to' ).html( accounting.formatMoney( max, {
                symbol:    woocommerce_price_slider_params.currency_format_symbol,
                decimal:   woocommerce_price_slider_params.currency_format_decimal_sep,
                thousand:  woocommerce_price_slider_params.currency_format_thousand_sep,
                precision: woocommerce_price_slider_params.currency_format_num_decimals,
                format:    woocommerce_price_slider_params.currency_format
            } ) );

            //if ( $( '.price_slider_amount span.from' ).length ) {
                $( document.body ).trigger( 'price_slider_updated', [ min, max ] );
            //}
        });

        function initPriceFilter() {
            if ( $('body').hasClass('shop-layout-no-sidebar') || !$( '.price_slider' ).length > 0 ) {
                return;
            }
            $( 'input#min_price, input#max_price' ).hide();
            $( '.price_slider, .price_label' ).show();

            var min_price         = $( '.price_slider_amount #min_price' ).data( 'min' ),
                max_price         = $( '.price_slider_amount #max_price' ).data( 'max' ),
                step              = $( '.price_slider_amount' ).data( 'step' ) || 1,
                current_min_price = $( '.price_slider_amount #min_price' ).val(),
                current_max_price = $( '.price_slider_amount #max_price' ).val();

            $( '.price_slider:not(.ui-slider)' ).slider({
                range  : true,
                animate: true,
                min    : min_price,
                max    : max_price,
                step   : step,
                values : [ current_min_price, current_max_price ],
                create : function() {

                    $( '.price_slider_amount #min_price' ).val( current_min_price );
                    $( '.price_slider_amount #max_price' ).val( current_max_price );

                    $( document.body ).trigger( 'price_slider_create', [ current_min_price, current_max_price ] );
                },
                slide: function( event, ui ) {

                    $( 'input#min_price' ).val( ui.values[0] );
                    $( 'input#max_price' ).val( ui.values[1] );

                    $( document.body ).trigger( 'price_slider_slide', [ ui.values[0], ui.values[1] ] );
                },
                change: function( event, ui ) {

                    $( document.body ).trigger( 'price_slider_change', [ ui.values[0], ui.values[1] ] );
                }
            });
        }

        initPriceFilter();
        $( document.body ).on( 'init_price_filter', initPriceFilter );

        var hasSelectiveRefresh = (
            'undefined' !== typeof wp &&
            wp.customize &&
            wp.customize.selectiveRefresh &&
            wp.customize.widgetsPreview &&
            wp.customize.widgetsPreview.WidgetPartial
        );
        if ( hasSelectiveRefresh ) {
            wp.customize.selectiveRefresh.bind( 'partial-content-rendered', function() {
                initPriceFilter();
            } );
        }

        var $min_price = $('.price_slider_amount #min_price');
        var $max_price = $('.price_slider_amount #max_price');
        var $products  = $('.products');

        if (typeof woocommerce_price_slider_params === 'undefined' || $min_price.length < 1 || !$.fn.slider) {
            return false;
        }

        var $slider = $('.price_slider');

        if ($slider.slider('instance') !== undefined) {
            return;
        }

        $('input#min_price, input#max_price').hide();
        $('.price_slider, .price_label').show();

        var min_price         = $min_price.data('min'),
            max_price         = $max_price.data('max'),
            current_min_price = parseInt(min_price, 10),
            current_max_price = parseInt(max_price, 10);

        if ($products.attr('data-min_price') && $products.attr('data-min_price').length > 0) {
            current_min_price = parseInt($products.attr('data-min_price'), 10);
        }

        if ($products.attr('data-max_price') && $products.attr('data-max_price').length > 0) {
            current_max_price = parseInt($products.attr('data-max_price'), 10);
        }

        $slider.slider({
            range  : true,
            animate: true,
            min    : min_price,
            max    : max_price,
            values : [
                current_min_price,
                current_max_price
            ],
            create : function() {
                $min_price.val(current_min_price);
                $max_price.val(current_max_price);

                $body.trigger('price_slider_create', [
                    current_min_price,
                    current_max_price
                ]);
            },
            slide  : function(event, ui) {
                $('input#min_price').val(ui.values[0]);
                $('input#max_price').val(ui.values[1]);

                $body.trigger('price_slider_slide', [
                    ui.values[0],
                    ui.values[1]
                ]);
            },
            change : function(event, ui) {
                $body.trigger('price_slider_change', [
                    ui.values[0],
                    ui.values[1]
                ]);
            }
        });

        setTimeout(function() {
            $body.trigger('price_slider_create', [
                current_min_price,
                current_max_price
            ]);

            if ($slider.find('.ui-slider-range').length > 1) {
                $slider.find('.ui-slider-range').first().remove();
            }
        }, 10);
    }

    function ajaxHandler() {

        $doc.pjax(links, '.ninetheme-shop-page-elementor', {
            timeout       : 5000,
            scrollTo      : false,
            renderCallback: function(context, html, afterRender) {
                context.html(html);
                afterRender();
            }
        });

        $doc.on('submit', '.ninetheme-shop-page-elementor .price_slider_wrapper form', function(event) {
            $.pjax.submit(event, '.ninetheme-shop-page-elementor');
        });

        $doc.on('pjax:error', function(xhr, textStatus, error) {
            console.log('pjax error ' + error);
        });

        $doc.on('pjax:start', function() {

            var $shopContent = $('.ninetheme-shop-page-elementor .products-ajax-content .ninetheme-products-wrapper');
            $shopContent.addClass('product-loading').append('<span class="loading-wrapper products-wrapper-loading"><span class="ajax-loading"></span></span>').css('min-height', 300);
            $(".products-ajax-content .ninetheme-products, .ninetheme-more, nav.ninetheme-woocommerce-pagination").hide();

            if ( ( typeof compare_vars != 'undefined' ) && compare_vars.products ) {
                var compare_ids = [];
                $('.ninetheme-product .ninetheme-compare-btn.added' ).each(function(){
                    compare_ids.push( $(this).data('id') );
                });
                compare_vars.products = compare_ids;
            }
            if ( ( typeof wishlist_vars != 'undefined' ) && wishlist_vars.products ) {
                var wishlist_ids = [];
                $('.ninetheme-product .ninetheme-wishlist-btn.added' ).each(function(){
                    wishlist_ids.push( $(this).data('id') );
                });
                wishlist_vars.products = wishlist_ids;
            }

            var headerStickyHeight = $('.ninetheme-header-sticky').height();

            var $offset = $('body').hasClass('admin-bar') ? 62 : 30;
            var $target = $('.ninetheme-before-loop').length>0 ? $('.ninetheme-before-loop') : $('.products-ajax-content');
            if ( $target.length>0 ) {
                $('html, body').stop().animate({
                    scrollTop: $target.offset().top - (headerStickyHeight+32)
                }, 800);
            } else {
                $('html, body').stop().animate({
                    scrollTop: $('.ninetheme-shop-page-elementor').offset().top
                }, 800);
            }
        });

        $doc.on('pjax:complete', function() {

            $('.ninetheme-products .product.animated' ).each(function(e, index){
                var delay = e/10;
                var anim = $(this).data('product-animation');
                $(this).css('animation-delay', delay+'s');
            });
            $doc.trigger('ninethemeShopInit');
        });

        $doc.on('pjax:end', function() {

        });
    }

    function ninethemeAfterRender() {

        if ( typeof $choosenContent == undefined || typeof $choosenContent == 'undefined' ) {
            $('.ninetheme-choosen-filters-row').removeClass('filters-active').html('');
        } else {
            $('.ninetheme-choosen-filters-row').addClass('filters-active').html($choosenContent);
        }

        if ( $('.woocommerce-ordering select').length ) {
            $('.woocommerce-ordering select').niceSelect();
        }


        $('.ninetheme-parallax').each(function (i, el) {

            var myParallax = $(el),
                myData     = myParallax.data('ninethemeParallax');
            if (!myData) {
                return true; // next iteration
            }
            myParallax.jarallax({
                type            : myData.type,
                speed           : myData.speed,
                imgSize         : myData.imgsize,
                imgSrc          : myData.imgsrc,
                disableParallax : myData.mobile ? /iPad|iPhone|iPod|Android/ : null,
                keepImg         : false,
            });
        });

        if ( $('.ninetheme-loop-slider') ) {
            $('.ninetheme-loop-slider').each(function () {
                const options = $(this).data('swiper-options');
                const mySlider = new NTSwiper(this, options);
            });
        }

        if ( $('.ninetheme-swiper-slider') ) {
            $('.ninetheme-swiper-slider').each(function () {
                const options = $(this).data('swiper-options');
                const mySlider = new NTSwiper(this, options);
            });
        }

        if ( $('.ninetheme-slick-slider') ) {
            $('.ninetheme-slick-slider').each(function () {
                $(this).not('.slick-initialized').slick();
            });
        }

        if ( typeof ninetheme_vars !== 'undefined' && ninetheme_vars ) {
            var colors = ninetheme_vars.swatches_color;

            $('.woocommerce-widget-layered-nav-list li a').each(function () {
                var $this = $(this);
                var title = $this.html();
                for (var i in colors) {
                    if ( title == i ) {
                        var is_white = colors[i] == '#fff' || colors[i] == '#ffffff' ? ' is_white' : '';
                        var color = '<span class="ninetheme-swatches-widget-color-item'+is_white+'" style="background-color: '+colors[i]+';"></span>';
                        $this.prepend(color);
                    }
                }
            });
            $('.elementor-widget-wp-widget-woocommerce_product_categories ul.children').each(function () {
                var $this = $(this);
                $this.before('<span class="subDropdown pluss"><svg class="svgPlus" width="426.66667pt" height="426.66667pt" fill="currentColor" viewBox="0 0 426.66667 426.66667" xmlns="http://www.w3.org/2000/svg"><path class="horizontal" d="m410.667969 229.332031h-394.667969c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h394.667969c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0"></path><path class="vertical" d="m213.332031 426.667969c-8.832031 0-16-7.167969-16-16v-394.667969c0-8.832031 7.167969-16 16-16s16 7.167969 16 16v394.667969c0 8.832031-7.167969 16-16 16zm0 0"></path></svg></span>');
            });
        }

        $('.site-scroll li.cat-parent.checked').each(function () {
            $(this).find('.subDropdown').trigger('click');
        });

        $('.nt-sidebar-widget-body li.checked, .nt-sidebar-widget-body .chosen').each(function () {
            $(this).parents('.nt-sidebar-widget-body').prev('.nt-sidebar-inner-widget-title').addClass('active');
        });

        $('.nt-sidebar-widget-body a').on('click', function (e) {
            $(this).parents('.nt-sidebar-widget-body').prev().toggleClass('active');
        });
    }

    function buttonsActions() {
        //Header cart Toggle
        $('.ninetheme-cart-btn').on('click', function () {
            $('.ninetheme-header-cart-details.minicart').toggleClass('active');
        });

        $('.nt-sidebar ul.product-categories li.cat-parent> ul.children').each( function (e) {
            $(this).slideUp();
        });

        $('.nt-sidebar ul.product-categories li.cat-parent .subDropdown').on('click', function (e) {
            $(this).toggleClass('active');
            $(this).next('.children').slideToggle();
        });

        $('.nt-sidebar-widget-body a').on('click', function (e) {
            $(this).prev().toggleClass('active');
        });

        $('.nt-sidebar-inner-widget-title').on('click', function() {
            var $this = $(this);
            $this.parents('.nt-sidebar-inner-widget').toggleClass('active');
            $this.next().slideToggle();
        });

        $( '.ninetheme-add-to-cart-btn .ajax_add_to_cart' ).on('click', function() {
            $(this).parent().addClass('added');
            $(this).parents( '.ninetheme-type-product' ).find('.ninetheme-thumb-wrapper').addClass('btn-ajax-start loading');
        });

    }

    function ninethemeDealsCountDown() {
        $('[data-countdown]').each(function () {
            var $this     = $(this),
                data      = $this.data('countdown'),
                finalDate = data.date,
                hr        = data.hr,
                min       = data.min,
                sec       = data.sec;
            $this.countdown(finalDate, function (event) {
                $this.html(event.strftime('<div class="time-count day"><span>%D</span>Day</div><div class="time-count hour"><span>%H</span>'+hr+'</div><div class="time-count min"><span>%M</span>'+min+'</div><div class="time-count sec"><span>%S</span>'+sec+'</div>'));
            });
        });
    }

    function ninethemeSidebarAddRemoveFilter() {
        $('.nt-sidebar-inner .woocommerce-widget-layered-nav-list__item.chosen a').each(function() {
            $(this).prepend('<span class="remove-filter"></span>');
        });
    }

    $doc.on('ninethemeShopInit', function() {
        ninethemeAfterRender();
        sortOrder();
        perPage();
        ninethemeSidebarAddRemoveFilter();
        buttonsActions();
        priceSlider();
        ninethemeDealsCountDown();

        $('.row-infinite').hide();

        $('.ninetheme-shop-page-elementor .variations_form').each(function () {
            $(this).wc_variation_form();
        });

        if ( ( typeof wishlist_vars != 'undefined' ) && wishlist_vars.products ) {
            var ids = wishlist_vars.products;
            for (let i = 0; i < ids.length; i++) {
              $('.ninetheme-wishlist-btn[data-id="'+ids[i]+'"]').addClass('added');
            }
        }
        if ( ( typeof compare_vars != 'undefined' ) && compare_vars.products ) {
            var ids = compare_vars.products;
            for (let i = 0; i < ids.length; i++) {
              $('.ninetheme-compare-btn[data-id="'+ids[i]+'"]').addClass('added');
            }
        }

        $('.ninetheme-loop-product-more-details-trigger').on('click', function (e) {
            $(this).parents('.ninetheme-type-product').toggleClass('details-open');
        });
    });

    $doc.ready(function() {
        //ninethemeAfterRender();
        sortOrder();
        perPage();
        ajaxHandler();
        ninethemeSidebarAddRemoveFilter();
        var chosenFilters = $( '.nt-sidebar .ninetheme-choosen-filters' ).html();

        if ( chosenFilters != undefined || typeof chosenFilters != 'undefined' ) {
            $('.ninetheme-choosen-filters-row').addClass('filters-active').html(chosenFilters);
        }

        if ( $('.ninetheme-filter-columns').length ) {
            $('.ninetheme-filter-columns li').on('click', function (e) {
                var col = $(this).data('column');
                $(this).addClass('active').siblings().removeClass('active');
                $('.ninetheme-products').removeAttr('class').addClass('ninetheme-products row '+col);
            });
        }
        if ( $('.ninetheme-per-page-item').length ) {
            $('.ninetheme-per-page-item').on('click', function (e) {
                $(this).addClass('active').siblings().removeClass('active');
            });
        }
    });

})(jQuery);
