jQuery(document).ready(function($) {

    /*-- Strict mode enabled --*/
    'use strict';

    var scrollOffset = $('.ninetheme-header-default').height();

    if ( $('body').hasClass('admin-bar') ) {
        scrollOffset = scrollOffset + 32;
    }

    var scrollToTopSidebar = function() {
        var shopP = 30;

        if ( $('body').hasClass('admin-bar') ) {
            shopP = 32;
        }

        $('html, body').stop().animate({
            scrollTop: $('.shop-area').offset().top - shopP
        }, 400);
    };

    $(document.body).on('click','.woocommerce-error .close-error', function (e) {
        $(this).parent().slideUp();
    });

    $('.ninetheme-open-fixed-sidebar,.ninetheme-close-sidebar').on('click', function () {
        $('body').toggleClass('ninetheme-overlay-open');
        $('.ninetheme-shop-fixed-sidebar,.nt-sidebar').toggleClass('active');
    });

    $('.ninetheme-toggle-hidden-sidebar').on('click', function (e) {

        $('.ninetheme-toggle-hidden-sidebar').toggleClass('active');
        $('.nt-sidebar.ninetheme-shop-hidden-top-sidebar').toggleClass('active').slideToggle();

        setTimeout(function(){
            scrollToTopSidebar();
        }, 100 );
    });

    $(document.body).on('update_checkout', function(){
        updateShippingButtonClick();
    });

    // cart shipping form show-hide
    function updateShippingButtonClick() {
        $('.ninetheme-shipping-calculator-button').on('click', function (e) {
            var cartTotals = $('.ninetheme-cart-totals'),
                form = $('.shipping-calculator-form');

            if ( cartTotals.hasClass('active')) {
                cartTotals.removeClass('active');
                form.slideUp('slow');
            } else {
                cartTotals.addClass('active');
                form.slideDown('slow');
                setTimeout(function(){
                    $('html, body').stop().animate({
                        scrollTop: cartTotals.offset().top - scrollOffset
                    }, 400);
                }, 300 );
            }
        });
    }
    updateShippingButtonClick();

    $('.nt-sidebar ul.product-categories li.cat-parent> ul.children').each( function (e) {
        $(this).slideUp();
    });

    ninethemeWcProductCats();
    function ninethemeWcProductCats() {
        $('.widget_ninetheme_product_categories ul.children input[checked]').closest('li.cat-parent').addClass("current-cat");

        $('body').off('click', '.subDropdown').on('click', '.subDropdown', function () {
            $(this).toggleClass("pluss"),
            $(this).toggleClass("minuss"),
            $(this).parent().find("ul").slideToggle();
        });
    }

    $('.nt-sidebar ul.product-categories li.cat-parent .subDropdown').on('click', function (e) {
        $(this).toggleClass('active');
        $(this).next('.children').slideToggle('slow');
    });

    $(document.body).on('click','.form-pw .btn-show-pw', function (e) {
        var parent = $(this).parents('.form-pw');
        var pw     = parent.find('input[id="password"]');
        if ( parent.hasClass('show-pw') ) {
            parent.removeClass('show-pw');
            pw.attr('type','password');
        } else {
            parent.addClass('show-pw');
            pw.attr('type','text');
        }
    });


    if ( $(window).width() <= 1280 && $(".ninetheme-bottom-mobile-nav").length ) {
        $("body").addClass('has-bottom-fixed-menu');
    }


    $(document.body).on('click','.ninetheme-shop-popup-notices .close-error', function() {
        $('.ninetheme-shop-popup-notices .woocommerce-notices-wrapper').remove();
    });

    shopCatsSlider();

    $(document).on('ninethemeShopInit', function() {
        shopCatsSlider();
        ninethemeWcProductCats();
    });

    function shopCatsSlider() {

        var product_cats = $('.ninetheme-products .slick-slide.product-category');

        if ( product_cats.length ) {
            product_cats.each(function (i, el) {
                $(this).appendTo('.shop-slider-categories .slick-slider');
            });
            var myContainer = $('.shop-slider-categories');
            var mySlick = $('.slick-slider', myContainer);
            mySlick.not('.slick-initialized').slick({
                autoplay: false,
                slidesToShow: 6,
                speed: 500,
                focusOnSelect: true,
                infinite: false,
                prevArrow: '.slide-prev-cats',
                nextArrow: '.slide-next-cats',
                responsive: [
                    {
                        breakpoint: 576,
                        settings: {
                            slidesToShow: 3
                        }
                    },
                    {
                        breakpoint: 768,
                        settings: {
                            slidesToShow: 4
                        }
                    },
                    {
                        breakpoint: 992,
                        settings: {
                            slidesToShow: 5
                        }
                    },
                    {
                        breakpoint: 1200,
                        settings: {
                            slidesToShow: 6
                        }
                    }
                ]
            });
        }
        if ( product_cats.length ) {
            var mySlick = $('.ninetheme-page-hero-content .ninetheme-wc-category-list');
            mySlick.not('.slick-initialized').slick({
                autoplay: false,
                slidesToShow: 8,
                speed: 500,
                focusOnSelect: true,
                infinite: false,
                prevArrow: '.slide-prev-cats',
                nextArrow: '.slide-next-cats',
                responsive: [
                    {
                        breakpoint: 576,
                        settings: {
                            slidesToShow: 3
                        }
                    },
                    {
                        breakpoint: 768,
                        settings: {
                            slidesToShow: 4
                        }
                    },
                    {
                        breakpoint: 992,
                        settings: {
                            slidesToShow: 5
                        }
                    },
                    {
                        breakpoint: 1200,
                        settings: {
                            slidesToShow: 6
                        }
                    }
                ]
            });
        }
    }

    /**
    * scrollToTop
    */
    function scrollToTop(target,delay,timeout) {
        setTimeout(function(){
            $('html, body').stop().animate({
                scrollTop: target.offset().top - scrollOffset
            }, delay);
        }, timeout );
    }

    /**
    * singleGalleryGridVariations
    */
    singleGalleryGridVariations();
    function singleGalleryGridVariations() {
        if ( !$('.ninetheme-product-main-gallery-grid .ninetheme-gallery-grid-item-first img').length ) {
            return;
        }
        var $oMainImg      = $('.ninetheme-product-main-gallery-grid .ninetheme-gallery-grid-item-first img'),
            $oMainSrc      = $oMainImg.data('src'),
            $oMainSrcSet   = $oMainImg.data('srcset'),
            $oMainSrcSizes = $oMainImg.data('sizes'),
            gallery        = $('.ninetheme-product-main-gallery-grid');

        $( document ).on('change','.ninetheme-product-summary .variations_form select', function( e ) {
            var $this      = $(this),
                $form      = $this.parents('.variations_form'),
                variations = $form.data('product_variations');

            setTimeout( function() {
                var current_id = $form.attr('current-image'),
                    image,
                    src,
                    srcset,
                    sizes;

                $.map(variations, function(elementOfArray, indexInArray) {
                    if ( elementOfArray.image_id == current_id ) {
                        image  = elementOfArray.image;
                        src    = image.src;
                        srcset = image.srcset;
                        sizes  = image.sizes;
                    }
                });
                if ( current_id ) {
                    $oMainImg.attr('src',src);
                    $oMainImg.attr('data-src',src);
                    if ( srcset ) {
                        $oMainImg.attr('srcset',srcset);
                    }
                    if ( sizes ) {
                        $oMainImg.attr('sizes',sizes);
                    }

                    scrollToTop(gallery,300,300);
                }
            }, 50 );

        });

        $( document ).on('click','.ninetheme-product-summary .reset_variations', function( e ) {
            var $form   = $(this).parents('.variations_form'),
                gallery = $('.ninetheme-product-main-gallery-grid');

            $oMainImg.attr('src',$oMainSrc);
            $oMainImg.attr('data-src',$oMainSrc);

            if ( $oMainSrcSet ) {
                $oMainImg.attr('srcset',$oMainSrcSet);
            }
            if ( $oMainSrcSizes ) {
                $oMainImg.attr('sizes',$oMainSrcSizes);
            }

            scrollToTop(gallery,400,300);
        });
    }

    /**
    * multiStepCheckout
    */
    multiStepCheckout();
    function multiStepCheckout() {
        var $body             = $('body'),
            login             = $('.ninetheme-woocommerce-checkout-login'),
            billing           = $('.ninetheme-customer-billing-details'),
            shipping          = $('.ninetheme-customer-shipping-details'),
            order             = $('.ninetheme-order-review'),
            payment           = $('.ninetheme-payment'),
            form_actions      = $('.ninetheme-form-actions'),
            coupon            = $('.ninetheme-checkout-coupon'),
            timeline          = $(),
            steps             = new Array(login, billing, shipping, order, payment),
            is_user_logged_in = $body.hasClass('logged-in');

        $body.on( 'updated_checkout ninetheme_multistep_myaccount_order_pay', function(e) {
            steps[4] = $('#payment');
            if(e.type == 'updated_checkout' ) {
                steps[4] = $('#payment');
            }
            $('#payment').find( 'input[name=payment_method]' ).on( 'click', function() {
                if ($('.payment_methods input.input-radio').length > 1) {
                    var target_payment_box = $('div.payment_box.' + $(this).attr('ID'));
                    if ($(this).is(':checked') && !target_payment_box.is(':visible')) {
                        $('div.payment_box').filter(':visible').slideUp(250);

                        if ($(this).is(':checked')) {
                            $('div.payment_box.' + $(this).attr('ID')).slideDown(250);
                        }
                    }
                } else {
                    $('div.payment_box').show();
                }

                if ($(this).data('order_button_text')) {
                    $('#place_order').val($(this).data('order_button_text'));
                } else {
                    $('#place_order').val($('#place_order').data('value'));
                }
            });
        } );

        if ($body.hasClass('woocommerce-order-pay')) {
            $body.trigger('ninetheme_multistep_myaccount_order_pay');
        }

        $body.on('ninetheme_multistep_select2', function (event) {
            if ($().select2) {
                var wc_country_select_select2 = function () {
                    $('select.country_select, select.state_select').each(function () {
                        var select2_args = {
                            placeholder      : $(this).attr('placeholder'),
                            placeholderOption: 'first',
                            width            : '100%'
                        };

                        $(this).select2(select2_args);
                    });
                };

                wc_country_select_select2();

                $body.bind('country_to_state_changed', function () {
                    wc_country_select_select2();
                });
            }
        });

        $body.trigger('ninetheme_multistep_select2');

        if ( $('.ninetheme-checkout-content').length ) {

            var checkoutMultiSteps = new NTSwiper('.ninetheme-checkout-content', {
                loop          : false,
                speed         : 500,
                spaceBetween  : 10,
                autoHeight    : true,
                nested        : true,
                observer      : true,
                observeParents: true,
                observeSlideChildren: true,
                simulateTouch : false,
                navigation    : {
                    nextEl: '.ninetheme-checkout-content .ninetheme-checkout-button-next',
                    prevEl: '.ninetheme-checkout-content .ninetheme-checkout-button-prev'
                },
                on: {
                    resize: function () {
                        var swiper = this;
                        swiper.update();
                    },
                    slideChange: function () {
                        var swiper = this;
                        var realIndex = swiper.realIndex;
                        $( '.ninetheme-step-item:not(:eq('+realIndex+'))' ).addClass('active');
                        $( '.ninetheme-step-item:eq('+realIndex+')' ).next().removeClass('active');
                        $( '.ninetheme-step-item:eq('+realIndex+')' ).next().next().removeClass('active');
                        swiper.updateAutoHeight(100);
                    }
                },
                effect: 'slide',
                pagination: {
                    el: ".ninetheme-page-multistep-checkout .ninetheme-swiper-pagination",
                    type: 'bullets',
                    bulletClass: 'ninetheme-bullets',
                    bulletClass: 'ninetheme-current',
                    bulletActiveClass: 'active',
                    clickable: true,
                    renderBullet: function (index, className) {
                        var labels = $('.ninetheme-page-multistep-checkout .ninetheme-swiper-pagination').data('steps-labels');
                        return '<div class="ninetheme-step-item ninetheme-step-item-' + (index + 1) + ' ' + className + '"><span class="ninetheme-step">' + (index + 1) + '</span><span class="ninetheme-step-label ninetheme-login">' + labels.labels[(index)] + '</span></div>';
                    }
                }
            });

            var checkoutLoginSteps = new NTSwiper('.ninetheme-checkout-form-login', {
                loop          : false,
                speed         : 500,
                spaceBetween  : 5,
                autoHeight    : true,
                simulateTouch : false,
                observer      : true,
                observeParents: true,
                observeSlideChildren: true,
                navigation    : {
                    nextEl: '.ninetheme-checkout-form-login .ninetheme-checkout-form-button-register',
                    prevEl: '.ninetheme-checkout-form-login .ninetheme-checkout-form-button-login'
                },
                on: {
                    resize: function () {
                        var swiper = this;
                        swiper.update();
                    },
                    slideChange: function () {
                        var swiper = this;
                        swiper.updateAutoHeight(100);
                    }
                },
                effect: 'slide'
            });

            $('body').on('input validate change', '.input-text, select, input:checkbox', function(e){
                var $this      = $( this ),
                    $parent    = $this.closest( '.form-row' ),
                    event_type = e.type;

                if ( 'validate' === event_type && $parent.hasClass( 'woocommerce-invalid-required-field' ) ) {

                    $( '.woocommerce-invalid-required-field' ).parents('.swiper-slide').addClass( 'has-error' );

                    setTimeout(function(){
                        var getInvalidSection = $( '.swiper-slide.has-error' ).index();
                        checkoutMultiSteps.slideTo(getInvalidSection);
                        checkoutMultiSteps.updateAutoHeight(10);
                    }, 300 );

                    if ( $('.woocommerce-NoticeGroup').length ) {
                        var $targetFirst = $('.woocommerce-NoticeGroup .woocommerce-error li:first-child').data('id'),
                            $targetFirstEl = $('#'+$targetFirst+'_field');
                    }
                }
            });
        }
    }

    $(document.body).on('added_to_cart removed_from_cart updated_cart_totals', function(){
        $(document.body).trigger("update_checkout");
        $(".ninetheme-product-bottom-popup-cart").removeClass('active');
    });

    if ( $('.woocommerce-error').length ) {
        $('.ninetheme-is-required').each(function () {
            if ( typeof ninetheme_vars !== 'undefined' && ninetheme_vars ) {
                var message = ninetheme_vars.required;
                $( this ).addClass('ninetheme-invalid').find( '.ninetheme-form-message' ).html(message);
            }
        });
    }

    var myAccountFormSteps = new NTSwiper('.ninetheme-myaccount-steps-register', {
        loop          : false,
        speed         : 500,
        spaceBetween  : 0,
        autoHeight    : false,
        simulateTouch : false,
        observer      : true,
        observerChildren      : true,
        navigation    : {
            nextEl: '.ninetheme-myaccount-steps-register .ninetheme-myaccount-form-button-register',
            prevEl: '.ninetheme-myaccount-steps-register .ninetheme-myaccount-form-button-login'
        },
        on: {
            resize: function () {
                var swiper = this;
                swiper.update();
            }
        },
        effect: 'slide'
    });

    $('body').on('ninetheme_myaccount_steps_register', function(){
        myAccountFormSteps.update();
    });

    if ( typeof ninetheme_vars !== 'undefined' && ninetheme_vars ) {
        var colors = ninetheme_vars.swatches_color;

        $('.woocommerce-widget-layered-nav-list li a').each(function () {
            var $this = $(this);
            var title = $this.html();
            for (var i in colors) {
                if ( title == i ) {
                    var is_white = colors[i] == '#fff' || colors[i] == '#ffffff' ? ' is_white' : '';
                    var color = '<span class="ninetheme-swatches-widget-color-item'+is_white+'" style="background-color: '+colors[i]+';"></span>';
                    $this.prepend(color);
                }
            }
        });
    }

    $('.ninetheme-wc-category-list a').on('click', function () {
        $('.ninetheme-wc-category-list a').removeClass("active");
        $(this).addClass("active");
    });

    if ($('body').hasClass('woocommerce-checkout') || $('body').hasClass('woocommerce-cart')) {
        $('.ninetheme-woocommerce-cart-form .product-remove').on('click touch', function(event) {
            $(this).addClass('loading');
        });
    }

    //ninethemeLoopTooltip();
    function ninethemeLoopTooltip() {
        var myTooltips = $('.ninetheme-product div[data-label]');
        myTooltips.each(function(i, el) {
            var content = $(el).data('label');
            $(el).tooltipster({
                position      : 'bottom',
                content       : content,
                animation     : 'fade',
                trigger       : 'hover',
                distance      : [ 20,200 ],
                arrow         : true,
                hideOnClick   : true,
                interactive   : false,
                touchDevices  : false,
                functionReady : function(){
                    var id  = this.__namespace;

                    $('#'+id).addClass('product-action-tooltips');
                }
            });
        });
    }

    ninethemeHeaderLocations();
    function ninethemeHeaderLocations() {
        if ( $('.ninetheme-location-area').length ) {
            var locationButton   = $( '.ninetheme-header-location-trigger, .top-action-btn[data-name="location"],li.menu-item a[data-name="location"]' );
            var locationData     = locationButton.data( 'location' );
            var locationSelected = $( '.ninetheme-header-location-trigger .ninetheme-header-current-location' );
            var locationClose    = $( '.ninetheme-close-popup' );
            var locationHolder   = $( '.ninetheme-header-location' );
            var locationOverlay  = $( '.ninetheme-location-overlay' );

            if ( typeof locationButton == 'undefined' ) {
                return;
            }

            var locationContent  = $( '.ninetheme-header-location' ).html();
            $('.location-area[ data-target-name="location"]').html(locationContent);

            locationButton.each(function() {
                $(this).on( 'click', function(e) {
                    e.preventDefault();

                    if ( $(this).hasClass('top-action-btn') || $(this).hasClass('location-trigger') ) {
                        $('.location-area[ data-target-name="location"] .ninetheme-location-area').select2("open");
                    } else {

                        if ( $(this).parents('.ninetheme-header-location').hasClass('active') ) {
                            $(this).parents('.ninetheme-header-location').removeClass( 'active' );
                        } else {
                            $(this).parents('.ninetheme-header-location').addClass( 'active' );
                            $('.ninetheme-header-location .ninetheme-location-area').select2("open");
                        }
                    }
                });
            });

            locationClose.on( 'click', function(e) {
                e.preventDefault();
                locationHolder.removeClass( 'active' );
            });

            locationOverlay.on( 'click', function(e) {
                e.preventDefault();
                locationHolder.removeClass( 'active' );
            });

            var minPrice = function(min) {
                if (!min.id) {
                    return min.text;
                }

                var $min;

                if ( min.element.dataset.min ) {
                    $min = $( '<span>' + min.text + '</span><span class="min-price">' + min.element.dataset.min + '</span>' );
                } else {
                    $min = min.text;
                }

                return $min;
            }

            $('.ninetheme-location-area').each(function() {
                var locations = $(this).select2({
                    allowClear       : true,
                    placeholder      : 'Select an option',
                    templateResult   : minPrice,
                    dropdownCssClass : 'ninetheme-location-select',
                    dropdownParent   : $(this).parent(),
                    closeOnSelect    : false,
                }).on("select2:closing", function(e) {
                    e.preventDefault();
                }).on("select2:closed", function(e) {
                    list.select2("open");
                });

                var placeholder = locations.data( 'placeholder' );

                locations.on( 'select2:open', function(e) {
                    $('.ninetheme-header-location .select2-results__options').addClass('ninetheme-scrollbar');
                    $('.select2-search__field').attr('placeholder', placeholder);
                    $('.select2-search').append('<svg data-testid="MagnifyGlass" viewBox="0 0 16 16" class="css-ekjjru"><path d="M14.23437,15.10449l-3.2539-3.25488a6.13908,6.13908,0,1,1,1.63574-1.85352c-.05859.10156-.11816.19922-.17969.29492l-.63086-.40625c.05567-.08593.10938-.17383.16016-.26269a5.406,5.406,0,1,0-1.19922,1.43945.37776.37776,0,0,1,.50781.02051l3.49121,3.49121Z" fill="currentColor"></path></svg>');
                });

                locations.on( 'select2:select', function(e) {
                    $.cookie("location", $(this).val());
                    if ( 'all' != $(this).val() ) {
                        $('.ninetheme-header-current-location').addClass( 'active' ).html($(this).val());
                    }
                    location.reload(true);
                    locationHolder.removeClass( 'active' );
                });
            });
        }
    }

    /***** panel Free Shipping Progressbar *****/

    if ( $('.ninetheme-cart-goal-wrapper').length>0 ) {
        var val = $('.ninetheme-cart-goal-wrapper .ninetheme-cart-goal-percent').val();
        if ( val >= 100 ) {
            $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
        }
    }

    panelFreeShippingProgressbar();

    function panelFreeShippingProgressbar() {
        var valPercent = $('.ninetheme-cart-goal-wrapper .ninetheme-cart-goal-percent').val();
        $('.ninetheme-free-shipping-progress .ninetheme-progress-bar').css('width', valPercent+'%');

        if ( valPercent >= 100 ) {
            $('.ninetheme-cart-goal-wrapper').addClass('free-shipping-success shakeY');
        } else {
            $('.ninetheme-cart-goal-wrapper').removeClass('free-shipping-success shakeY');
        }
    }

    /***** panel Free Shipping Progressbar *****/

    /***** compare button fix *****/

    if ( $('#woosc-area').length> 0) {
        var woosc = $('#woosc-area').data('count');
        $('.ninetheme-compare-count').html(woosc);
        $('.woosc-bar-item').each(function () {
            var $id = $(this).attr('data-id');
            $('.woosc-btn-icon-only[data-id="'+$id+'"]').addClass('woosc-added added');
        });
    }

    $(document.body).on('woosc_change_count', function(){
	     var woosc_count = $('#woosc-area').attr('data-count');
	     $('.ninetheme-compare-count').html(woosc_count);
    });

    /***** compare button fix *****/

    /***** wishlist button fix *****/

    var w_count = $('.open-wishlist-btn .woosw-menu-item-inner').attr('data-count');
    if ( typeof w_count != 'undefined' ) {
        $('.ninetheme-wishlist-count').html(w_count);
    } else {
        $('.ninetheme-wishlist-count').html('0');
    }
    if ( $('table.woosw-items').length > 0 ) {
        $('body').addClass('woosw-page');
    }

	$(document.body).on('.ninetheme-wishlist-btn','click', function(){
		$(this).addClass('added');
	});

    $(document.body).on('woosw_fragments_refreshed', function(){
        var wishlist_count = $('.woosw-count').html();
        $('.ninetheme-wishlist-count').html( wishlist_count );

        if ( $('body').hasClass('woosw-page') ) {
            var w_count2 = $('.woosw-items.table .woosw-item').length;
            if ( typeof w_count != 'undefined' ) {
                $('.ninetheme-wishlist-count').html( w_count2 );
            } else {
                $('.ninetheme-wishlist-count').html(0);
            }
        }
    });

    /***** wishlist button fix *****/


    /***** change sku *****/

    var $mainSkuHtml = $('.ninetheme-sku-wrapper .sku'),
        $mainSku     = $mainSkuHtml.html();

    $('.ninetheme-product-summary form.variations_form').on('show_variation', function( event, data ){
        $mainSkuHtml.html(data.sku);
        $('.ninetheme-btn-reset-wrapper,.single_variation_wrap').addClass('active');
    });
    $('.ninetheme-product-summary form.variations_form').on('hide_variation', function(){
        $mainSkuHtml.html($mainSku);
        $('.ninetheme-btn-reset-wrapper,.single_variation_wrap').removeClass('active');
    });

    /***** change sku *****/

    if ( $('.nt-woo-single .ninetheme-related-slider').length ) {
        var optionsRelated = $('.nt-woo-single .ninetheme-related-slider').data('swiper-options');
        var relatedSlider  = new NTSwiper('.ninetheme-related-slider', optionsRelated );
    }
    if ( $('.ninetheme-upsells-slider').length ) {
        var optionsUpsells = $('.ninetheme-upsells-slider').data('swiper-options');
        var upsellsSlider  = new NTSwiper('.ninetheme-upsells-slider', optionsUpsells );
    }
    if ( $('.ninetheme-cross-sells-slider').length ) {
        var optionsCrosssells = $('.ninetheme-cross-sells-slider').data('swiper-options');
        var crosssellsSlider  = new NTSwiper('.ninetheme-cross-sells-slider', optionsCrosssells );
    }
    if ( $('.ninetheme-recently-slider').length ) {
        var optionsRecently = $('.ninetheme-recently-slider').data('swiper-options');
        var recentlySlider  = new NTSwiper('.ninetheme-recently-slider', optionsRecently );
    }
});
