<?php

if ( ! function_exists( 'ninetheme_side_panel_cart_content' ) ) {
    add_action( 'ninetheme_before_wp_footer', 'ninetheme_side_panel_cart_content' );
    function ninetheme_side_panel_cart_content()
    {
        global $woocommerce;
        $cart_count    = $woocommerce->cart->cart_contents_count;
        $autoopen      = '1' == ninetheme_settings('disable_right_panel_auto', '0' ) ? ' disable-auto-open' : '';
        $counter_attr  = 'counter-'.ninetheme_settings( 'header_buttons_counter_position', 'right' );
        $counter_attr .= ' counter-'.ninetheme_settings( 'header_buttons_counter_bgcolor_type', 'primary' );
        $counter_attr .= ' counter-'.ninetheme_settings( 'header_buttons_counter_radius_type', 'radius' );
        $cart_count    = WC()->cart->get_cart_contents_count();
        ?>
        <div class="ninetheme-side-panel<?php echo esc_attr( $autoopen ); ?>" data-cart-count="<?php echo esc_attr( $cart_count ); ?>">
            <div class="panel-header <?php echo esc_attr( $counter_attr ); ?>">
                <div class="ninetheme-panel-close ninetheme-panel-close-button"></div>
                <div class="panel-header-actions">

                    <div class="panel-header-cart">
                        <span class="ninetheme-cart-total"><?php echo WC()->cart->get_cart_subtotal(); ?></span>
                        <div class="panel-header-btn" data-name="cart">
                            <span class="ninetheme-cart-count ninetheme-wc-count"><?php echo esc_html($cart_count); ?></span>
                            <?php echo ninetheme_svg_lists( 'bag', 'ninetheme-svg-icon' ); ?>
                        </div>
                    </div>

                    <?php if ( class_exists( 'WPCleverWoosw' ) ) { ?>
                        <div class="panel-header-wishlist panel-header-btn open-wishlist-btn">
                            <div class="woosw-menu-item ninetheme-hidden"><span class="woosw-menu-item-inner"></span></div>
                            <span class="ninetheme-wishlist-count ninetheme-wc-count"></span>
                            <?php echo ninetheme_svg_lists( 'love', 'ninetheme-svg-icon' ); ?>
                        </div>
                    <?php } ?>

                    <?php if ( class_exists( 'WPCleverWoosc' ) ) { ?>
                        <div class="panel-header-compare panel-header-btn open-compare-btn">
                            <span class="ninetheme-compare-count ninetheme-wc-count"></span>
                            <?php echo ninetheme_svg_lists( 'compare', 'ninetheme-svg-icon' ); ?>
                        </div>
                    <?php } ?>

                    <?php do_action( 'ninetheme_side_panel_header_after_cart' ); ?>
                </div>
            </div>

            <?php do_action( 'ninetheme_side_panel_after_header' ); ?>

            <div class="panel-content">
                <div class="cart-area panel-content-item active" data-name="cart">
                    <div class="cart-content">
                        <?php get_template_part('woocommerce/minicart/minicart'); ?>
                    </div>
                </div>
                <?php do_action( 'ninetheme_side_panel_content_after_cart' ); ?>
            </div>
        </div>
        <?php
    }
}
