<?php
/**
* Related Products
*
* This template can be overridden by copying it to yourtheme/woocommerce/single-product/related.php.
*
* HOWEVER, on occasion WooCommerce will need to update template files and you
* (the theme developer) will need to copy the new files to your theme to
* maintain compatibility. We try to do this as little as possible, but it does
* happen. When this occurs the version of the template file will be bumped and
* the readme will list any important changes.
*
* @see         https://docs.woocommerce.com/document/template-structure/
* @package     WooCommerce\Templates
* @version     3.9.0
*/

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

if ( '1' != ninetheme_settings('single_shop_ralated_visibility', '1') ) {
    return;
}

if ( '1' == ninetheme_settings('product_ralated_same_category', '0') ) {

    wc_get_template_part( 'single-product/related-category' );

} else {

    $heading = ninetheme_settings('single_shop_related_title', '');
    $heading = $heading ? esc_html( $heading ) : apply_filters('woocommerce_product_related_products_heading', esc_html__('Viewers Also Liked', 'crisop' ));

    $slider_options = json_encode(array(
        "loop"          => '1' == ninetheme_settings( 'shop_related_loop', '0' ) ? true : false,
        "speed"         => intval(ninetheme_settings( 'shop_related_speed', 800 )),
        "spaceBetween"  => intval(ninetheme_settings( 'shop_related_gap', 20 )),
        "slidesPerView" => 1,
        "grabCursor"    => true,
        "autoHeight"    => true,
        "watchSlidesProgress" => true,
        "autoplay"      => '1' == ninetheme_settings( 'shop_related_autoplay', 1 ) ? ["pauseOnMouseEnter" => true,"disableOnInteraction" => false] : false,
        "navigation"    => [
            "nextEl" => ".related-slider-nav .ninetheme-slide-next",
            "prevEl" => ".related-slider-nav .ninetheme-slide-prev"
        ],
        "breakpoints"   => [
            "0" => [
                "slidesPerView" => intval(ninetheme_settings( 'shop_related_smperview', 2 ))
            ],
            "768" => [
                "slidesPerView" => intval(ninetheme_settings( 'shop_related_mdperview', 3 ))
            ],
            "1024" => [
                "slidesPerView" => intval(ninetheme_settings( 'shop_related_perview', 4 ))
            ]
        ]
    ));

    if ( $related_products ) {
        wp_enqueue_script( 'swiper' );
        ?>
        <div class="ninetheme-product-related ninetheme-section">
            <div class="section-title-wrapper">
                <?php if ( $heading ) : ?>
                    <h6 class="section-title"><?php echo esc_html( $heading ); ?></h6>
                <?php endif; ?>
                <div class="related-slider-nav slider-nav-top">
                    <div class="ninetheme-slide-prev swiper-button-prev"></div>
                    <div class="ninetheme-slide-next swiper-button-next"></div>
                </div>
            </div>
            <div class="ninetheme-wc-swipper-wrapper woocommerce style-1">
                <div class="ninetheme-related-slider swiper-container" data-swiper-options="<?php echo esc_attr( $slider_options ); ?>">
                    <div class="swiper-wrapper">

                        <?php
                        foreach ( $related_products as $related_product ) : ?>
                            <div class="swiper-slide">
                                <?php
                                $post_object = get_post( $related_product->get_id() );
                                setup_postdata( $GLOBALS['post'] =& $post_object );
                                wc_get_template_part( 'content', 'product' );
                                ?>
                            </div>

                        <?php endforeach; ?>
                    </div>
                </div>
            </div>
        </div>
        <?php
    }
    wp_reset_postdata();
}
